SystemOrganization addCategory: #'SOUL-Kernel'!

!RBFormatter methodsFor: '*SOUL-Kernel' stamp: 'AndyKellens 11/2/2011 09:53'!
visitDelayedSoulVariable: aSoulVariable
	
	codeStream
		nextPutAll:
			(SoulFactory current makeDelayedVariable name: aSoulVariable name)
				smalltalkBlockString! !

!RBFormatter methodsFor: '*SOUL-Kernel' stamp: 'AndyKellens 11/2/2011 09:53'!
visitSoulVariable: aSoulVariable
	
	codeStream
		nextPutAll:
			(SoulFactory current makeVariable name: aSoulVariable name)
				smalltalkBlockString! !

!String methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
asSourceString
	
	^self asString! !

!String methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
capitalized
	"Return a copy with the first letter capitalized"

	
	| cap |
	self isEmpty ifTrue: [^self copy].
	cap := self copy.
	cap
		at: 1
		put: (cap at: 1) asUppercase.
	^cap! !

!String methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
isAllDigits
	"whether the receiver is composed entirely of digits"

	
	^(self contains: [:c | c isDigit not]) not! !

!String methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
printAsPrologOn: aStream scope: id in: env startAt: idx
	
	| fixedCopy |
	fixedCopy := (self copyReplaceAll: '\' with: '\\') copyReplaceAll: '"'
		with: '\"'.
	aStream nextPut: $".
	aStream nextPutAll: fixedCopy.
	aStream nextPut: $"! !

!String methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
putOn: aStream
	
	^aStream nextPutAll: self! !

!Stream methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
write: encodedObject
	
	^encodedObject putOn: self! !

!Symbol methodsFor: '*SOUL-Kernel' stamp: 'AndyKellens 11/2/2011 09:53'!
asSoulConstant
	
	^SoulFactory current makeConstant name: self! !

!Symbol methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
printAsPrologOn: aStream scope: id in: env startAt: idx
	
	| fixedCopy |
	(self contains: [:c | c isLetter not]) | self first isUppercase
		ifTrue:
			[fixedCopy := (self copyReplaceAll: '\' with: '\\') copyReplaceAll: '"'
				with: '\"'.
			aStream nextPut: $'.
			aStream nextPutAll: fixedCopy.
			aStream nextPut: $']
		ifFalse: [aStream nextPutAll: self]! !

!Symbol methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
speciesAppend: aSequnceableCollection
	"Answer a copy of the receiver concatenated with the 
	argument, a SequenceableCollection."

	"Roel: The regular #, does not take the type of the receiver into 
	account. For example, appending symbols results in a String."

	"The default implementation falls back on #,. Subclasses that 
	have problems (such as Symbol) can override this to return the 
	correct type."

	
	^(self , aSequnceableCollection) asSymbol! !

!Symbol methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
speciesCopyFrom: startIndex to: stopIndex
	"Roel: The regular #copyFrom:to: does not take the type of the 
	receiver into account, so copying a part from a symbol results 
	in a String. This method makes sure that the result is a Symbol."

	
	^(self copyFrom: startIndex to: stopIndex) asSymbol! !

!True methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
degree
	
	^1! !

!False methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
degree
	
	^0! !

Error subclass: #SoulError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

SoulError subclass: #SoulParseError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

SoulError subclass: #SoulRuntimeException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!SoulRuntimeException methodsFor: 'initialize-release' stamp: 'sp 24/10/11 15:26'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	
	super initialize.	" *** Replace this comment with the appropriate initialization code *** "

	^self! !

!Collection methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
write: anObject
	
	self add: anObject.
	^anObject! !

!Integer methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
printAsPrologOn: aStream scope: id in: env startAt: idx
	
	self printOn: aStream! !

!Character methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
isBlank
	"Relied upon but not provided by SmaCCScanner, also provided by RBCodeHighlighting."

	"space or tab"

	
	^self == $  or: [self == $	]! !

!RBProgramNode methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
asRBNodeIn: anEnv startAt: anIndex
	
	^self copy! !

!RBProgramNode methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
asSourceString
	
	^self formattedCode! !

!RBProgramNode methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
cachedSoulChildren
	
	cachedSoulChildren
		ifNil:
			[cachedSoulChildren := self soulChildren collect: [:aChild | aChild soulUp]].
	^cachedSoulChildren! !

!RBProgramNode methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
functor
	
	^self class name soulUp! !

!RBProgramNode methodsFor: '*SOUL-Kernel' stamp: 'AndyKellens 11/2/2011 09:53'!
listTermFrom: start to: stop
	
	| coll |
	coll := OrderedCollection new.
	start
		to: stop
		do: [:i | coll add: (self cachedSoulChildren at: i)].
	^SoulFactory current makeList new
		addChildrenInitial: (OrderedCollection with: (TermSequence terms: coll))! !

!RBProgramNode methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
multiplicity
	
	^self cachedSoulChildren size! !

!RBProgramNode methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
soulChildren
	
	^self children! !

!RBProgramNode methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
soulUp
	
	^UppedASTObject up: self! !

!RBProgramNode methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
unifyWithCompoundTerm: aCompound inEnv: anEnv myIndex: sourceIndex hisIndex: targetIndex inSource: inSource
	
	^(self functor
		unifyWith: aCompound functor
		inEnv: anEnv
		myIndex: sourceIndex
		hisIndex: targetIndex
		inSource: inSource) & (self multiplicity = aCompound multiplicity)
		and:
			[aCompound termSequence terms
				doWithIndex:
					[:otherTerm :i | 
					(otherTerm isKindOf: UnderscoreVariable)
						ifFalse:
							[((self cachedSoulChildren at: i) unifyWith: otherTerm inEnv: anEnv
								myIndex: sourceIndex hisIndex: targetIndex inSource: inSource)
								ifFalse: [^false]]].
			true]! !

!RBProgramNode methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
unifyWithVarArgsCompoundTerm: aCompound inEnv: anEnv myIndex: sourceIndex hisIndex: targetIndex inSource: inSource
	
	| varargsmultiplicity |
	varargsmultiplicity := aCompound realmultiplicity.
	^(self functor
		unifyWith: aCompound functor
		inEnv: anEnv
		myIndex: sourceIndex
		hisIndex: targetIndex
		inSource: inSource) & (self multiplicity >= varargsmultiplicity)
		and:
			[varargsmultiplicity = 1
				ifTrue:
					[(self
						listTermFrom: 1
						to: self multiplicity)
						unifyWith: (aCompound termSequence terms at: 1)
						inEnv: anEnv
						myIndex: sourceIndex
						hisIndex: targetIndex
						inSource: inSource]
				ifFalse:
					[1
						to: varargsmultiplicity - 1
						do:
							[:index | 
							((aCompound termSequence terms at: index)
								unifyWith: (self cachedSoulChildren at: index)
								inEnv: anEnv
								myIndex: targetIndex
								hisIndex: sourceIndex
								inSource: inSource not) ifFalse: [^false]].
					(self
						listTermFrom: varargsmultiplicity
						to: self multiplicity)
						unifyWith: (aCompound termSequence terms at: varargsmultiplicity)
						inEnv: anEnv
						myIndex: sourceIndex
						hisIndex: targetIndex
						inSource: inSource]]! !

!Boolean methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
isMaybe
	
	^false! !

!SequenceableCollection methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
findFirst: aBlock startingAt: anIndex
	"Taken from TreeModel"

	
	anIndex
		to: self size
		do: [:index | (aBlock value: (self at: index)) ifTrue: [^index]].
	^0! !

!SequenceableCollection methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
speciesAppend: aSequnceableCollection
	"Answer a copy of the receiver concatenated with the 
	argument, a SequenceableCollection."

	"Roel: The regular #, does not take the type of the receiver into 
	account. For example, appending symbols results in a String."

	"The default implementation falls back on #,. Subclasses that 
	have problems (such as Symbol) can override this to return the 
	correct type."

	
	^self , aSequnceableCollection! !

!SequenceableCollection methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
speciesCopyFrom: startIndex to: stopIndex
	"Roel: The regular #copyFrom:to: does not take the type of the 
	receiver into account. For example, copying a part from a 
	symbol results in a String."

	"The default implementation falls back on #copyFrom:to:. 
	Subclasses that have problems (such as Symbol) can override 
	this to return the correct type."

	
	^self copyFrom: startIndex to: stopIndex! !

!SequenceableCollection methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
with: aSequenceableCollection do: aBlock separatedBy: separatorBlock
	"Evaluate aBlock with each of the receiver's elements along with the corresponding
	element from aSequencableCollection."

	
	| otherCollection |
	self size ~= aSequenceableCollection size ifTrue: [^self noMatchError].
	otherCollection := ReadStream on: aSequenceableCollection.
	self
		do:
			[:each | 
			aBlock
				value: each
				value: otherCollection next]
		separatedBy: separatorBlock! !

!RBConfigurableFormatter methodsFor: '*SOUL-Kernel' stamp: 'AndyKellens 11/2/2011 09:53'!
visitDelayedSoulVariable: aSoulVariable
	
	codeStream
		nextPutAll:
			(SoulFactory current makeDelayedVariable name: aSoulVariable name)
				smalltalkBlockString! !

!RBConfigurableFormatter methodsFor: '*SOUL-Kernel' stamp: 'AndyKellens 11/2/2011 09:53'!
visitSoulVariable: aSoulVariable
	
	codeStream
		nextPutAll:
			(SoulFactory current makeVariable name: aSoulVariable name)
				smalltalkBlockString! !

Object subclass: #CallGraph
	instanceVariableNames: 'nodes nodeMapping clauseNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!CallGraph commentStamp: '<historical>' prior: 0!
CallGraph has not been commented.  The comment should state the purpose of the class and also explain any unobvious aspects of the implementation.

Instance Variables
	nodeMapping	<Dictionary> maps termName/multiplicity to an index
	nodes	<(Array of: (JavaArray | SequenceableCollection))>	2dim array with boolean if idxA calls idxB

!

!CallGraph class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
withClauses: aCollection
	
	| graph |
	graph := CallGraph new withClauses: aCollection.
	^graph! !

!CallGraph methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
getAllConnected: anInteger
	
	| res |
	res := OrderedCollection new.
	(nodes at: anInteger) doWithIndex: [:e :i | e isNil ifFalse: [res add: i]].
	^res! !

!CallGraph methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
getConnected: anInteger with: anotherInteger
	
	^(nodes at: anInteger) at: anotherInteger! !

!CallGraph methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
getIndex: termString
	
	^nodeMapping
		at: termString
		ifAbsent: [nil]! !

!CallGraph methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
initializeNodesWith: anInteger
	
	nodes := Array new: anInteger.
	1
		to: anInteger
		do:
			[:x | 
			nodes
				at: x
				put: (Array new: anInteger)]! !

!CallGraph methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
isClauseConnected: theClause with: aClause visited: aCollection
	
	| connectedTo |
	(aCollection contains: [:x | theClause = x])
		ifTrue: [^false]
		ifFalse: [aCollection add: theClause].
	theClause = aClause ifTrue: [^true].
	connectedTo := nodeMapping at: theClause.
	^connectedTo
		contains:
			[:x | self isClauseConnected: x with: aClause visited: aCollection]! !

!CallGraph methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
isConnected: aTerm withClause: aClause
	
	| res termString clausesImplementingTerm |
	termString := aTerm functor asString , aTerm multiplicity asString.
	res := OrderedCollection new.
	clausesImplementingTerm := clauseNames
		at: termString
		ifAbsent: [^res].
	clausesImplementingTerm
		do:
			[:theClause | 
			(self
				isClauseConnected: theClause
				with: aClause
				visited: OrderedCollection new) ifTrue: [res add: theClause]].
	^res! !

!CallGraph methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
isTermConnected: aTerm withClause: aClause
	
	| result |
	result := self isConnected: aTerm withClause: aClause.
	^result! !

!CallGraph methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
processClause: aClause
	
	aClause condition
		do: [:aTerm | self processTerm: aTerm fromClause: aClause]! !

!CallGraph methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
processClauses: aCollection
	
	aCollection do: [:aClause | self processClause: aClause]! !

!CallGraph methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
processComplexTerm: aTerm fromClause: aClause
	
	aTerm termSequence
		do: [:term | self processTerm: term fromClause: aClause]! !

!CallGraph methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
processTerm: aTerm fromClause: aClause
	
	| functor funcMul coll |
	aTerm isCompoundTerm
		ifTrue:
			[functor := aTerm functor asString.
			(#('not' 'or' 'and') contains: [:x | x = functor])
				ifTrue: [^self processComplexTerm: aTerm fromClause: aClause].
			funcMul := functor , aTerm multiplicity asString.
			coll := nodeMapping at: aClause.
			coll
				addAll:
					(clauseNames
						at: funcMul
						ifAbsent:
							[Transcript show: 'ignored unknown term in CallGraph: ' , funcMul.
							OrderedCollection new])]! !

!CallGraph methodsFor: 'initialize-release' stamp: 'sp 24/10/11 15:26'!
withClauses: aCollection
	
	| coll |
	nodeMapping := Dictionary new.
	clauseNames := Dictionary new.
	aCollection
		do:
			[:aClause | 
			| name |
			name := aClause conclusion functor asString
				, aClause conclusion multiplicity asString.
			coll := clauseNames
				at: name
				ifAbsent:
					[clauseNames
						at: name
						put: OrderedCollection new].
			coll add: aClause.
			nodeMapping
				at: aClause
				put: OrderedCollection new].
	self processClauses: aCollection! !

Object variableSubclass: #CallStack
	instanceVariableNames: 'currentIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!CallStack class methodsFor: 'instance creation' stamp: 'AndyKellens 10/28/2011 11:14'!
new
	
	^(super new: 6000) initialize! !

!CallStack class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
newFrom: aStack
	
	^self new initializeFrom: aStack! !

!CallStack methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
asFrameList
	
	| list |
	list := List new.
	(1 to: currentIndex - 1) do: [:index | list add: (self at: index)].
	^list reverse! !

!CallStack methodsFor: 'copying' stamp: 'sp 24/10/11 15:26'!
clone
	
	^self class newFrom: self! !

!CallStack methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
cut
	
	| frame |
	[frame := self pop.
	frame isEmpty
		ifFalse: [frame cuttop]
		ifTrue:
			[self push: frame.
			true]] whileFalse! !

!CallStack methodsFor: 'initialize-release' stamp: 'sp 24/10/11 15:26'!
initialize
	
	currentIndex := 1! !

!CallStack methodsFor: 'initialize-release' stamp: 'sp 24/10/11 15:26'!
initializeFrom: aStack
	
	currentIndex := aStack size + 1.
	(1 to: currentIndex - 1)
		do:
			[:i | 
			self
				at: i
				put: (aStack at: i)]! !

!CallStack methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
isEmpty
	
	^currentIndex == 1! !

!CallStack methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
pop
	
	currentIndex := currentIndex - 1.
	^self at: currentIndex! !

!CallStack methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printOn: aStream
	
	aStream
		print: self class;
		nextPutAll: ' ['.
	(1 to: currentIndex - 1)
		do: [:index | (self at: index) printOn: aStream]
		separatedBy: [aStream nextPutAll: ', '].
	aStream nextPut: $]! !

!CallStack methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
push: anElement
	
	self at: currentIndex put: anElement.
	currentIndex := currentIndex + 1! !

!CallStack methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
size
	
	^currentIndex - 1! !

!CallStack methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
top
	
	^self at: currentIndex - 1! !

Object subclass: #DepthFirstRuleSelector
	instanceVariableNames: 'callstack env vars startedIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!DepthFirstRuleSelector methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
callStack
	
	^callstack! !

!DepthFirstRuleSelector methodsFor: 'evaluation' stamp: 'AndyKellens 11/2/2011 09:53'!
evalQuery: inQuery
	"build the first workframe, the failframe and the callstack"

	
	| condition startframe failframe |
	startframe := DepthFirstFrame new.
	failframe := FailFrame new.
	callstack := CallStack new.
	env := SoulFactory current makeEnvironment new.
	inQuery makeClean.
	inQuery accept: (LexicalAddressVisitor on: inQuery definitionRepository).
	vars := inQuery variables.
	env callStack: callstack.
	condition := inQuery condition.
	startedIndex := env currentVariableIndex.	"initialize the startframe with the conditions of the query"

	condition
		reverseDo:
			[:curCondition | 
			startframe
				push:
					(TermPointer
						term: curCondition
						envIndex: env currentVariableIndex)].
	failframe rollbackInfo: env rollbackInfo.
	env startUnifyWith: inQuery.
	startframe rollbackInfo: env rollbackInfo.	"put the failframe and the first frame on the callstack"

	callstack push: failframe.
	callstack push: startframe! !

!DepthFirstRuleSelector methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
evalQuery: inQuery inEnv: anEnv startAt: anIndex
	"only to be used by the evaluator"

	
	| condition startframe failframe |
	startframe := DepthFirstFrame new.
	failframe := FailFrame new.
	callstack := CallStack new.
	vars := inQuery variables.
	env := anEnv.
	env callStack: callstack.
	condition := inQuery condition.
	startedIndex := anIndex.	"initialize the startframe with the conditions of the query"

	condition
		reverseDo:
			[:curCondition | startframe push: (TermPointer term: curCondition envIndex: anIndex)].
	failframe rollbackInfo: env rollbackInfo.
	startframe rollbackInfo: env rollbackInfo.	"put the failframe and the first frame on the callstack"

	callstack push: failframe.
	callstack push: startframe! !

!DepthFirstRuleSelector methodsFor: 'private' stamp: 'AndyKellens 11/2/2011 09:53'!
evalTermApplication: aTermApplication inEnv: anEnv
	"only to be used by the evaluator"

	
	| startframe failframe conditions query |
	startframe := DepthFirstFrame new.
	failframe := FailFrame new.
	callstack := CallStack new.	"change the below to avoid making a query"

	conditions := OrderedCollection new.
	conditions add: aTermApplication term.
	query := SoulFactory current makeQuery
		condition: (SoulFactory current makeTermSequence terms: conditions).
	vars := query variables.
	env := anEnv.
	env callStack: callstack.
	startedIndex := aTermApplication envIndex.	"initialize the startframe with the conditions of the query"

	startframe push: aTermApplication.
	failframe rollbackInfo: env rollbackInfo.
	startframe rollbackInfo: env rollbackInfo.	"put the failframe and the first frame on the callstack"

	callstack push: failframe.
	callstack push: startframe! !

!DepthFirstRuleSelector methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
expandStack: aFrameCollection
	"expand the stack with new frames"

	
	aFrameCollection reverseDo: [:aFrame | callstack push: aFrame]! !

!DepthFirstRuleSelector methodsFor: 'evaluation' stamp: 'sp 24/10/11 15:26'!
next
	"pop the currentframe from the stack, if it does not contain any  
	condition-clauses, it is a succes. Hence, it contains a result-binding  
	which is consequently fetched.  
	If it is not empty, set the data-stack to the position of the frame,  
	resolve the frame and expand the stack with the resulting frames"

	
	| currentFrame result |
	[(currentFrame := callstack pop) isEmpty]
		whileFalse: [self expandStack: (currentFrame resolveIn: env)].
	currentFrame rollback: env.
	result := currentFrame resultOf: vars in: env startAt: startedIndex.	"the end of the stack always contains a failframe, which should always 
	be returned if the next result is asked at the end of the eval process"

	result == false ifTrue: [callstack push: currentFrame].
	^result! !

!DepthFirstRuleSelector methodsFor: 'evaluation' stamp: 'sp 24/10/11 15:26'!
step
	"QUICK HACK TO MAKE CONFESS WORK"

	
	| currentFrame result |
	(currentFrame := callstack pop) isEmpty
		ifFalse:
			[self expandStack: (currentFrame resolveIn: env).
			^nil]
		ifTrue:
			[currentFrame rollback: env.
			result := currentFrame resultOf: vars in: env startAt: startedIndex.
			result == false ifTrue: [callstack push: currentFrame].
			^result]! !

Object subclass: #Environment
	instanceVariableNames: 'variableArray bindingArray bindingIndex bindingRollbackIndex variableRollbackIndex variableIndex variableMax bindingMax callStack currentFrame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!Environment commentStamp: '<historical>' prior: 0!
Environment has not been commented.  The comment should state the purpose of the class and also explain any unobvious aspects of the implementation.

Instance Variables:
	bindingArray	<Array>	description of bindingArray
	bindingIndex	<ArithmeticValue>	description of bindingIndex
	bindingMax	<ArithmeticValue | CPointer>	description of bindingMax
	bindingRollbackIndex	<Date | Number | SmaCCEdge>	description of bindingRollbackIndex
	callStack	<LUIProxy | Object | Proxy>	description of callStack
	currentFrame	not used by crisp interpreter, but used by fuzzy interpreter
	variableArray	<(Collection of: (Object | ObjectProxy))>	description of variableArray
	variableIndex	<ArithmeticValue>	description of variableIndex
	variableMax	<ArithmeticValue | CPointer>	description of variableMax
	variableRollbackIndex	<LUIProxy | Object | Proxy>	description of variableRollbackIndex

!

!Environment class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
new
	
	^super new initialize! !

!Environment methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
bind: aVariable to: aValue startAt: startIndex valueStartAt: valueStartIndex
	"This method adds ground variable bindings to the environment"

	
	| index nextIndex |
	index := startIndex + aVariable address.
	variableArray
		at: index
		put: (TermPointer term: aValue envIndex: valueStartIndex).
	nextIndex := self nextBindingIndex.
	bindingArray at: nextIndex put: index! !

!Environment methodsFor: 'callStack' stamp: 'sp 24/10/11 15:26'!
callStack
	
	^callStack! !

!Environment methodsFor: 'callStack' stamp: 'sp 24/10/11 15:26'!
callStack: aStack
	
	callStack := aStack! !

!Environment methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
currentFrame
	
	^currentFrame! !

!Environment methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
currentFrame: aFrame
	
	currentFrame := aFrame! !

!Environment methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
currentVariableIndex
	
	^variableIndex! !

!Environment methodsFor: 'constants' stamp: 'sp 24/10/11 15:26'!
incrementSize
	
	^500! !

!Environment methodsFor: 'constants' stamp: 'sp 24/10/11 15:26'!
initialSize
	
	^4000! !

!Environment methodsFor: 'initialize' stamp: 'sp 24/10/11 15:26'!
initialize
	"All elements must be nil, this is standard for making a new array"

	
	variableArray := Array new: self initialSize.
	bindingArray := Array new: self initialSize.
	bindingIndex := 1.
	variableIndex := 1.
	bindingMax := self initialSize.
	variableMax := self initialSize! !

!Environment methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
lookup: aVar startAt: startIndex
	
	| index |
	index := startIndex + aVar address.
	index > variableArray size ifTrue: [^nil].
	^variableArray at: index! !

!Environment methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
nextBindingIndex
	
	| temp |
	bindingIndex = bindingMax ifTrue: [self resizeBindings].
	temp := bindingIndex.
	bindingIndex := bindingIndex + 1.
	^temp! !

!Environment methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printOn: aStream
	
	aStream write: '['.
	variableArray
		do: [:value | value printOn: aStream]
		separatedBy: [aStream cr].
	aStream write: ']'! !

!Environment methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
resizeBindings
	"TODO: use Array replaceFrom: to: with:"

	
	| newArray |
	bindingMax := bindingMax + self incrementSize.
	newArray := Array new: bindingMax.
	1
		to: bindingIndex
		do:
			[:i | 
			newArray
				at: i
				put: (bindingArray at: i)].
	bindingArray := newArray! !

!Environment methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
resizeVariables: minimum
	"TODO: use Array replaceFrom: to: with:"

	
	| newArray |
	variableMax := variableMax + (self incrementSize max: minimum).
	newArray := Array new: variableMax.
	1
		to: variableArray size
		do:
			[:i | 
			newArray
				at: i
				put: (variableArray at: i)].
	variableArray := newArray! !

!Environment methodsFor: 'unification-transactions' stamp: 'sp 24/10/11 15:26'!
rollback
	
	(bindingRollbackIndex to: bindingIndex - 1)
		do:
			[:i | 
			variableArray
				at: (bindingArray at: i)
				put: nil].
	bindingIndex := bindingRollbackIndex.
	variableIndex := variableRollbackIndex! !

!Environment methodsFor: 'unification-transactions' stamp: 'sp 24/10/11 15:26'!
rollbackInfo
	
	^Array with: bindingIndex with: variableIndex! !

!Environment methodsFor: 'unification-transactions' stamp: 'sp 24/10/11 15:26'!
rollbackTo: aRollBackInfo
	
	| newbindingIndex |
	newbindingIndex := aRollBackInfo at: 1.
	newbindingIndex
		to: bindingIndex - 1
		do:
			[:i | 
			variableArray
				at: (bindingArray at: i)
				put: nil].
	bindingIndex := newbindingIndex.
	variableIndex := aRollBackInfo at: 2! !

!Environment methodsFor: 'unification-transactions' stamp: 'sp 24/10/11 15:26'!
startUnify: aNumber
	
	bindingRollbackIndex := bindingIndex.
	variableRollbackIndex := variableIndex.
	variableIndex + aNumber > variableMax
		ifTrue: [self resizeVariables: variableMax - variableIndex + aNumber].
	variableIndex := variableIndex + aNumber.
	^variableRollbackIndex! !

!Environment methodsFor: 'unification-transactions' stamp: 'sp 24/10/11 15:26'!
startUnifyWith: aHornClause
	
	^self startUnify: aHornClause envSize! !

!Environment methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
transitiveLookup: aVar startAt: anIndex
	
	^aVar transitiveLookupIn: self startAt: anIndex! !

Object subclass: #Frame
	instanceVariableNames: 'envRollbackInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

Frame subclass: #CutTopFrame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!CutTopFrame methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
cuttop
	
	^true! !

!CutTopFrame methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
isEmpty
	
	^false! !

!CutTopFrame methodsFor: 'evaluation' stamp: 'sp 24/10/11 15:26'!
resolveIn: anEnv
	
	^OrderedCollection new! !

Frame subclass: #DepthFirstFrame
	instanceVariableNames: 'conditionsList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

DepthFirstFrame subclass: #DepthFirstChoiceFrame
	instanceVariableNames: 'resolver cuttop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!DepthFirstChoiceFrame class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
withResolver: aResolver clauses: clauses rollbackInfo: aRollbackInfo cuttop: aState
	
	^self new withResolver: aResolver clauses: clauses rollbackInfo:
			aRollbackInfo cuttop: aState! !

!DepthFirstChoiceFrame methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
cuttop
	
	^cuttop! !

!DepthFirstChoiceFrame methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
displayString
	
	^resolver displayString , super displayString! !

!DepthFirstChoiceFrame methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
isEmpty
	
	^false! !

!DepthFirstChoiceFrame methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printOn: aStream
	
	aStream
		print: self class;
		nextPutAll: ' ('.
	resolver printOn: aStream.
	aStream nextPutAll: ')['.
	conditionsList printOn: aStream.
	aStream nextPut: $]! !

!DepthFirstChoiceFrame methodsFor: 'evaluation' stamp: 'sp 24/10/11 15:26'!
resolveIn: anEnv
	"fetch the resolution of the next candidate clause, produce a frame and  
	check if the resolver still has candidate clauses"

	"first rollback the environment"

	
	| resolutionResult results newFrame |
	self rollback: anEnv.
	results := OrderedCollection new.
	resolutionResult := resolver nextResolution.
	resolutionResult
		ifNotNil:
			[newFrame := DepthFirstFrame fromConditionsStack: conditionsList.
			newFrame fromResolution: resolutionResult.
			results add: newFrame.
			cuttop := resolutionResult cutTopDelimiter].
	resolver isEmpty
		ifFalse: [results add: self]
		ifTrue: [cuttop ifTrue: [results add: CutTopFrame new]].
	^results! !

!DepthFirstChoiceFrame methodsFor: 'initialize' stamp: 'sp 24/10/11 15:26'!
withResolver: aResolver clauses: aStack rollbackInfo: aRollbackInfo cuttop: aState
	
	conditionsList := aStack.
	resolver := aResolver.
	self rollbackInfo: aRollbackInfo.
	cuttop := aState! !

!DepthFirstFrame class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
fromConditionsStack: aStack
	
	^super new conditionsList: aStack! !

!DepthFirstFrame class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
new
	
	^super new initialize! !

!DepthFirstFrame methodsFor: 'copying' stamp: 'sp 24/10/11 15:26'!
clone
	
	^self class fromConditionsStack: conditionsList! !

!DepthFirstFrame methodsFor: 'initialize' stamp: 'sp 24/10/11 15:26'!
conditionsList: aStack
	
	conditionsList := aStack! !

!DepthFirstFrame methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
displayString
	
	| stream current |
	stream := WriteStream on: String new.
	current := conditionsList.
	[current == nil]
		whileFalse:
			[stream nextPutAll: conditionsList displayString , ' , '.
			current := current nextTerm].
	^stream contents! !

!DepthFirstFrame methodsFor: 'initialize' stamp: 'sp 24/10/11 15:26'!
fromResolution: aResolutionResult
	
	| conditionsEnvIndex |
	envRollbackInfo := aResolutionResult rollbackInfo.
	conditionsEnvIndex := aResolutionResult conditionsEnvIndex.
	aResolutionResult conditions
		reverseDo:
			[:condition | 
			conditionsList := TermPointer term: condition envIndex: conditionsEnvIndex
				nextTerm: conditionsList]! !

!DepthFirstFrame methodsFor: 'initialize' stamp: 'sp 24/10/11 15:26'!
initialize
	
	conditionsList := nil! !

!DepthFirstFrame methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
isEmpty
	
	^conditionsList == nil! !

!DepthFirstFrame methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printOn: aStream
	
	aStream
		print: self class;
		nextPutAll: ' ['.
	conditionsList printOn: aStream.
	aStream nextPut: $]! !

!DepthFirstFrame methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
push: aClause
	
	conditionsList := aClause nextTerm: conditionsList! !

!DepthFirstFrame methodsFor: 'evaluation' stamp: 'sp 24/10/11 15:26'!
resolveIn: anEnv
	"produces frames to be pushed onto the searchspace: one frame for the  
	resolution of the first condition with a first candidate from the  
	repository and a continuationFrame for the next candidates.  
	The other conditions in this frame are taken along into the new frames"

	
	| resolutionResult results resolver tempcuttop |
	"first roll back the environment"

	self rollback: anEnv.
	results := OrderedCollection new.
	resolver := conditionsList resolveIn: anEnv.
	conditionsList := conditionsList nextTerm.
	resolutionResult := resolver nextResolution.	"the resolver now encapsulates the resolution of the clause with other  
	candidate clauses"

	resolver isEmpty
		ifTrue:
			["an empty resolver means tail-recursion using the current  
			resolutionresult"

			resolutionResult
				ifNotNil:
					[results add: (self fromResolution: resolutionResult).
					resolutionResult cutTopDelimiter
						ifTrue: [results add: CutTopFrame new]]]
		ifFalse:
			["a non-empty resolver means splitting the searchspace in this  
			resolutionresult and a continuationframe containing the other  
			candidate expansionframes"

			tempcuttop := false.
			resolutionResult
				ifNotNil:
					[results add: (self clone fromResolution: resolutionResult).
					tempcuttop := resolutionResult cutTopDelimiter].
			results
				add:
					(DepthFirstChoiceFrame
						withResolver: resolver
						clauses: conditionsList
						rollbackInfo: self rollbackInfo
						cuttop: tempcuttop)].
	^results! !

!DepthFirstFrame methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
resultOf: vars in: env startAt: startIndex
	
	| return |
	return := vars
		collect:
			[:var | 
			(var isKindOf: DelayedVariable)
				ifTrue:
					[Binding
						var: var
						value: (var transitiveLookupIn: env startAt: startIndex) soulUp]
				ifFalse:
					[Binding
						var: var
						value: (var soulDownIn: env startAt: startIndex) soulUp]].
	^return! !

Frame subclass: #FailFrame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!FailFrame methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
displayString
	
	^'fail'! !

!FailFrame methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
isEmpty
	
	^true! !

!FailFrame methodsFor: 'evaluation' stamp: 'sp 24/10/11 15:26'!
resolveIn: anEnv
	
	^false! !

!FailFrame methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
resultOf: vars in: env startAt: startIndex
	
	^false! !

!Frame methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
cuttop
	
	^false! !

!Frame methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
isEmpty
	
	^self subclassResponsibility! !

!Frame methodsFor: 'evaluation' stamp: 'sp 24/10/11 15:26'!
resolveIn: anEnv
	
	^self subclassResponsibility! !

!Frame methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
resultOf: vars in: env startAt: startIndex
	
	^self subclassResponsibility! !

!Frame methodsFor: 'evaluation' stamp: 'sp 24/10/11 15:26'!
rollback: anEnv
	
	anEnv rollbackTo: self rollbackInfo! !

!Frame methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
rollbackInfo
	
	^envRollbackInfo! !

!Frame methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
rollbackInfo: aRollbackInfo
	
	envRollbackInfo := aRollbackInfo! !

Object subclass: #Maybe
	instanceVariableNames: 'degree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!Maybe commentStamp: '<historical>' prior: 0!
Instances represent unification degrees and behave as booleans.

Although regular Soul only uses crisp degrees, putting its definition here instead of in the fuzzy Soul package saves us from having to specialize MLI's and domain-specific unifications for both variants. 

For instance, domain-specific unifications defined by Cava on the org.eclipse.jdt.dom hierarchy use this class rather than booleans such that one definition suffices for crisp Soul and fuzzy Soul. !

!Maybe class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
degree: aNumber
	
	aNumber = 0 ifTrue: [^false].
	aNumber = 1 ifTrue: [^true].
	^self new degree: aNumber! !

!Maybe methodsFor: 'logical operations' stamp: 'sp 24/10/11 15:26'!
& alternativeObject
	"Evaluating conjunction.  Answer alternativeObject since receiver is true."

	
	^alternativeObject! !

!Maybe methodsFor: 'controlling' stamp: 'sp 24/10/11 15:26'!
and: alternativeBlock
	"Nonevaluating conjunction -- answer the value of alternativeBlock since
	the receiver is true."

	"Execution does not actually reach here because the expression is compiled in-line."

	
	^alternativeBlock value! !

!Maybe methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
degree
	
	^degree! !

!Maybe methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
degree: anObject
	
	degree := anObject! !

!Maybe methodsFor: 'delegation' stamp: 'sp 24/10/11 15:26'!
doesNotUnderstand: aMessage
	
	^self degree > 0
		perform: aMessage selector
		withArguments: aMessage arguments! !

!Maybe methodsFor: 'controlling' stamp: 'sp 24/10/11 15:26'!
ifFalse: alternativeBlock
	"Since the condition is true, the value is the true alternative, which 
	is nil. This method is typically not invoked because ifTrue:/ifFalse: 
	expressions are compiled in-line for literal blocks."

	
	^nil! !

!Maybe methodsFor: 'controlling' stamp: 'sp 24/10/11 15:26'!
ifFalse: falseAlternativeBlock ifTrue: trueAlternativeBlock
	"Answer the value of trueAlternativeBlock. This method is typically 
	not invoked because ifTrue:/ifFalse: expressions are compiled in-line 
	for literal blocks."

	
	^trueAlternativeBlock value! !

!Maybe methodsFor: 'controlling' stamp: 'sp 24/10/11 15:26'!
ifTrue: alternativeBlock
	"Answer the value of alternativeBlock. This method is typically not 
	invoked because ifTrue:/ifFalse: expressions are compiled in-line for 
	literal blocks."

	
	^alternativeBlock value! !

!Maybe methodsFor: 'controlling' stamp: 'sp 24/10/11 15:26'!
ifTrue: trueAlternativeBlock ifFalse: falseAlternativeBlock
	"Answer the value of trueAlternativeBlock. This method is typically 
	not invoked because ifTrue:/ifFalse: expressions are compiled in-line 
	for literal blocks."

	
	^trueAlternativeBlock value! !

!Maybe methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
isMaybe
	
	^true! !

!Maybe methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
mustBeBoolean
	
	^true! !

!Maybe methodsFor: 'logical operations' stamp: 'sp 24/10/11 15:26'!
not
	"Negation--answer false since the receiver is true."

	
	^false! !

!Maybe methodsFor: 'controlling' stamp: 'sp 24/10/11 15:26'!
or: alternativeBlock
	"Nonevaluating disjunction -- answer true since the receiver is true."

	"Execution does not actually reach here because the expression is compiled in-line."

	
	^self! !

!Maybe methodsFor: 'logical operations' stamp: 'sp 24/10/11 15:26'!
| aBoolean
	"Evaluating disjunction (OR) -- answer true since the receiver is true."

	
	^self! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
accept: aVisitor
	
	self shouldNotImplement! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
asSourceString
	"This message gets send to an object if it is used inside a quotedcode. The result should be the textual representation of the object; as desired. Subclasses might 	want to override this message"

	
	| stream |
	stream := WriteStream on: String new.
	self printOn: stream.
	^stream contents! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
asSourceStringIn: anEnv startAt: index
	"this necessary to make quotedcode work when some variables are already filled in, because of an earlier downing process"

	
	^self asSourceString! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
asString
	"Answer a string that represents the receiver."

	"Squeak Compatibility"

	
	^self printString! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
explicitSoulUp
	
	^self soulUp! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
isNumber
	
	^false! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
printAsPrologOn: aStream scope: id in: env startAt: idx
	"Most object cannot be translated to Prolog. Rather than outputting an error though, we output a stub."

	
	aStream nextPutAll: 'object'! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
putOn: aStream
	
	^aStream nextPut: self! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
soulDownIn: anEnv startAt: anIndex
	
	^self! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'AndyKellens 11/2/2011 09:53'!
soulUp
	
	^SoulFactory current makeUppedObject up: self! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
todo: msg
	
	! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
ugly: msg
	
	! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
unifyWith: aTerm inEnv: anEnv myIndex: myIndex hisIndex: hisIndex inSource: inSource
	
	self shouldNotImplement! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
unifyWithCompoundTerm: aCompound inEnv: anEnv myIndex: myIndex hisIndex: hisIndex inSource: inSource
	
	self shouldNotImplement! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
unifyWithDelayedVariable: aVariable inEnv: anEnv myIndex: sourceIndex hisIndex: targetIndex inSource: inSource
	
	self shouldNotImplement! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
unifyWithKeywordedCompound: aCompound inEnv: anEnv myIndex: sourceIndex hisIndex: targetIndex inSource: inSource
	
	self shouldNotImplement! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
unifyWithNegVariable: aVariable inEnv: anEnv myIndex: sourceIndex hisIndex: targetIndex inSource: inSource
	
	self shouldNotImplement! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
unifyWithPosVariable: aVariable inEnv: anEnv myIndex: sourceIndex hisIndex: targetIndex inSource: inSource
	
	self shouldNotImplement! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
unifyWithQuotedCodeTerm: aQCTerm inEnv: anEnv myIndex: sourceIndex hisIndex: targetIndex inSource: inSource
	
	self shouldNotImplement! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
unifyWithSmalltalkTerm: anSTTerm inEnv: anEnv myIndex: myIndex hisIndex: hisIndex inSource: inSource
	
	self shouldNotImplement! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
unifyWithTemplateQueryTerm: aTQCTerm inEnv: anEnv myIndex: sourceIndex hisIndex: targetIndex inSource: inSource
	
	self shouldNotImplement! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
unifyWithUppedObject: anObject inEnv: anEnv myIndex: myIndex hisIndex: hisIndex inSource: inSource
	
	self shouldNotImplement! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
unifyWithVarArgsCompoundTerm: aCompound inEnv: anEnv myIndex: sourceIndex hisIndex: targetIndex inSource: inSource
	
	self shouldNotImplement! !

!Object methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
unifyWithVariable: aVariable inEnv: anEnv myIndex: myIndex hisIndex: hisIndex inSource: inSource
	
	self shouldNotImplement! !

Object subclass: #RegexGoal
	instanceVariableNames: 'transitionsTo termsequence goalId variables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!RegexGoal class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
newWith: aCollection id: anInteger variables: varCollection
	
	^self new initializeWith: aCollection id: anInteger variables:
			varCollection! !

!RegexGoal methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
connectTo: aGoal transition: aRegexTransitionClass
	
	transitionsTo add: (aRegexTransitionClass from: self to: aGoal)! !

!RegexGoal methodsFor: 'converting' stamp: 'sp 24/10/11 15:26'!
generateGoal: aTerm definitionRepository: aDefinitionRepository
	
	| string |
	termsequence size = 0
		ifTrue:
			[string := string := 'goal' , aTerm identifier asString , '('
				, goalId asString , ',' , variables asString , ', ?currentWorld)']
		ifFalse:
			[string := 'goal' , aTerm identifier asString , '(' , goalId asString , ','
				, variables asString , ', ?currentWorld) if ' , termsequence asString].
	^RegexTerm generateRule: string definitionRepository:
			aDefinitionRepository! !

!RegexGoal methodsFor: 'converting' stamp: 'sp 24/10/11 15:26'!
generateTransitions: aRegexTerm term: term definitionRepository: aRepository
	
	self generateGoal: aRegexTerm definitionRepository: aRepository.
	transitionsTo
		collect:
			[:trans | 
			trans
				generateTransitions: aRegexTerm identifier
				term: term
				definitionRepository: aRepository]! !

!RegexGoal methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
goalId
	
	^goalId! !

!RegexGoal methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
goalId: anObject
	
	goalId := anObject! !

!RegexGoal methodsFor: 'initialize-release' stamp: 'sp 24/10/11 15:26'!
initializeWith: aCollection id: anInteger variables: varCollection
	
	termsequence := TermSequence terms: aCollection.
	transitionsTo := OrderedCollection new.
	goalId := anInteger.
	variables := varCollection! !

!RegexGoal methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
termsequence
	
	^termsequence! !

!RegexGoal methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
termsequence: anObject
	
	termsequence := anObject! !

!RegexGoal methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
transitionsTo
	
	^transitionsTo! !

!RegexGoal methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
transitionsTo: anObject
	
	transitionsTo := anObject! !

!RegexGoal methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
variables
	
	^variables! !

!RegexGoal methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
variables: anObject
	
	variables := anObject! !

Object subclass: #RegexTransition
	instanceVariableNames: 'from to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

RegexTransition subclass: #RegexEndTransition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!RegexEndTransition methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
generateExistentialCondition: identifier term: aTerm
	
	^' if ' , 'goal' , identifier asString , '(' , from goalId asString ,
			',?phi, ?evalIn)'! !

!RegexEndTransition methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
generateExistentialHead: identifier term: aTerm
	
	^'npattern' , identifier asString , '(?phi, ' , from goalId asString , ','
		, to goalId asString , ',?evalIn, ?evalIn, ?fromWorld, ?fromWorld) '! !

!RegexEndTransition methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
generateUniversalCondition: identifier term: aTerm
	
	^' if forall(goal' , identifier asString , '(' , from goalId asString ,
			',?phi, ?evalIn))'! !

RegexTransition subclass: #RegexEpsilonTransition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

RegexEpsilonTransition subclass: #RegexCuttedEpsilonTransition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!RegexCuttedEpsilonTransition methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
generateExistentialCondition: identifier term: aTerm
	
	^' if !!'! !

!RegexCuttedEpsilonTransition methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
generateUniversalCondition: identifier term: aTerm
	
	^' if !!'! !

!RegexEpsilonTransition methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
generateExistentialCondition: identifier term: aTerm
	
	^''! !

!RegexEpsilonTransition methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
generateExistentialHead: identifier term: aTerm
	
	^'npattern' , identifier asString , '(?phi, ' , from goalId asString , ','
		, to goalId asString , ',?evalIn, ?evalIn, ?fromWorld, ?fromWorld) '! !

!RegexEpsilonTransition methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
generateUniversalCondition: identifier term: aTerm
	
	^''! !

!RegexEpsilonTransition methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
generateUniversalHead: identifier term: aTerm
	
	^'npatternUniversal' , identifier asString , '(?phi, '
		, from goalId asString , ',' , to goalId asString ,
			',?evalIn, ?evalIn, ?fromWorld, ?fromWorld)'! !

!RegexTransition class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
from: aGoal to: anotherGoal
	
	^self new from: aGoal to: anotherGoal! !

!RegexTransition methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
from
	
	^from! !

!RegexTransition methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
from: anObject
	
	from := anObject! !

!RegexTransition methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
from: aGoal to: anotherGoal
	
	self from: aGoal.
	self to: anotherGoal! !

!RegexTransition methodsFor: 'converting' stamp: 'sp 24/10/11 15:26'!
generateExistential: identifier term: aTerm definitionRepository: aDefinitionRepository
	
	| string |
	string := (self generateExistentialHead: identifier term: aTerm)
		, (self generateExistentialCondition: identifier term: aTerm).
	^RegexTerm generateRule: string definitionRepository:
			aDefinitionRepository! !

!RegexTransition methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
generateExistentialCondition: identifier term: aTerm
	
	^' if ' , 'goal' , identifier asString , '(' , from goalId asString ,
			',?phi, ?evalIn), ' , aTerm asString ,
			'(?fromWorld, ?toWorld, ?nextEvalIn)'! !

!RegexTransition methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
generateExistentialHead: identifier term: aTerm
	
	^'npattern' , identifier asString , '(?phi, ' , from goalId asString , ','
		, to goalId asString , ',?evalIn, ?nextEvalIn, ?fromWorld, ?toWorld) '! !

!RegexTransition methodsFor: 'converting' stamp: 'sp 24/10/11 15:26'!
generateTransitions: identifier term: aTerm definitionRepository: aDefinitionRepository
	
	self generateExistential: identifier term: aTerm definitionRepository:
			aDefinitionRepository.
	self generateUniversal: identifier term: aTerm definitionRepository:
			aDefinitionRepository! !

!RegexTransition methodsFor: 'converting' stamp: 'sp 24/10/11 15:26'!
generateUniversal: identifier term: aTerm definitionRepository: aDefinitionRepository
	
	| string |
	string := (self generateUniversalHead: identifier term: aTerm)
		, (self generateUniversalCondition: identifier term: aTerm).
	^RegexTerm generateRule: string definitionRepository:
			aDefinitionRepository! !

!RegexTransition methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
generateUniversalCondition: identifier term: aTerm
	
	^' if forall(goal' , identifier asString , '(' , from goalId asString ,
			',?phi, ?evalIn)),' , aTerm asString ,
			'(?fromWorld, ?toWorld, ?nextEvalIn)'! !

!RegexTransition methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
generateUniversalHead: identifier term: aTerm
	
	^'npatternUniversal' , identifier asString , '(?phi, '
		, from goalId asString , ',' , to goalId asString ,
			',?evalIn, ?nextEvalIn, ?fromWorld, ?toWorld)'! !

!RegexTransition methodsFor: 'initialize-release' stamp: 'sp 24/10/11 15:26'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	
	super initialize.	" *** Edit the following to properly initialize instance variables ***"

	from := nil.
	to := nil.	" *** And replace this comment with additional initialization code *** "

	^self! !

!RegexTransition methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
to
	
	^to! !

!RegexTransition methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
to: anObject
	
	to := anObject! !

Object subclass: #ResolutionResult
	instanceVariableNames: 'conditions rollbackInfo conditionsEnvIndex cutTopDelimiter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!ResolutionResult class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
condition: aCondition rollbackInfo: aRollbackInfo conditionsEnvIndex: condIndex cutState: cutState
	
	^self new condition: aCondition rollbackInfo: aRollbackInfo
		conditionsEnvIndex: condIndex cutState: cutState! !

!ResolutionResult methodsFor: 'initialize' stamp: 'sp 24/10/11 15:26'!
condition: aCondition rollbackInfo: aRollbackInfo conditionsEnvIndex: condIndex cutState: cutState
	
	conditions := aCondition.
	rollbackInfo := aRollbackInfo.
	conditionsEnvIndex := condIndex.
	cutTopDelimiter := cutState! !

!ResolutionResult methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
conditions
	
	^conditions! !

!ResolutionResult methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
conditionsEnvIndex
	
	^conditionsEnvIndex! !

!ResolutionResult methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
cutTopDelimiter
	
	^cutTopDelimiter! !

!ResolutionResult methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printOn: aStream
	
	aStream
		write: 'resolutionresult with conditions: ';
		cr.
	conditions printOn: aStream.
	aStream
		cr;
		write: ' and rollbackInfo: ';
		cr.
	rollbackInfo printOn: aStream.
	aStream cr! !

!ResolutionResult methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
rollbackInfo
	
	^rollbackInfo! !

Object subclass: #Resolver
	instanceVariableNames: 'clause delayedClauses clauseIndex env startIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

Resolver subclass: #NativeResolver
	instanceVariableNames: 'block args pos argsSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!NativeResolver class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
onBlock: aBlock withArguments: args
	
	^self new onBlock: aBlock withArguments: args! !

!NativeResolver methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
displayString
	
	^'EXPAND(' , block displayString , ')'! !

!NativeResolver methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
isEmpty
	
	^pos >= argsSize! !

!NativeResolver methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
nextResolution
	
	pos := pos + 1.
	^block value: (args at: pos)! !

!NativeResolver methodsFor: 'initialize' stamp: 'sp 24/10/11 15:26'!
onBlock: aBlock withArguments: anArgs
	
	block := aBlock.
	args := anArgs.
	argsSize := args size.
	pos := 0! !

!Resolver class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
fromClause: aClause toClauses: aSetOfClauses inEnv: anEnv startAt: anIndex
	
	^self new fromClause: aClause toClauses: aSetOfClauses inEnv: anEnv
		startAt: anIndex! !

!Resolver methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
displayString
	
	^'EXPAND(' , clause displayString , ')'! !

!Resolver methodsFor: 'initialize' stamp: 'sp 24/10/11 15:26'!
fromClause: aClause toClauses: aSetOfClauses inEnv: anEnv startAt: anIndex
	
	clause := aClause.
	clauseIndex := 1.
	delayedClauses := aSetOfClauses.
	env := anEnv.
	startIndex := anIndex! !

!Resolver methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
isEmpty
	
	^clauseIndex > delayedClauses size! !

!Resolver methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
nextResolution
	"Fetch the next candidate clause. start the transaction on the  
	environment. resolve the clause and the candidate clause. Bindings are  
	created in the environment as a side-effect of unification. On succes,  
	commit the bindings to the environment, otherwise perform a rollback.  
	The result is a resolution, containing the new conditions and the  
	backtrack-index in the environment"

	
	| result currentHornClause targetSource hisIndex |
	[result isNil & (clauseIndex <= delayedClauses size)]
		whileTrue:
			[currentHornClause := delayedClauses at: clauseIndex.
			clauseIndex := clauseIndex + 1.
			targetSource := currentHornClause conclusion innerTerm.
			hisIndex := env startUnifyWith: currentHornClause.
			(clause
				unifyWith: targetSource term
				inEnv: env
				myIndex: startIndex
				hisIndex: hisIndex
				inSource: true)
				ifTrue:
					[result := ResolutionResult
						condition: currentHornClause condition
						rollbackInfo: env rollbackInfo
						conditionsEnvIndex: hisIndex
						cutState: currentHornClause containsCut]
				ifFalse: [env rollback]].
	^result! !

!Resolver methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printOn: aStream
	
	aStream
		print: self class;
		nextPutAll: ' <'.
	clauseIndex printOn: aStream.
	aStream nextPut: $/.
	delayedClauses size printOn: aStream.
	aStream nextPut: $>! !

Object subclass: #SLGCall
	instanceVariableNames: 'callTerm waitingNodes cid answers evaluator plink nlink comp dfn negativeWaitingNodes slgQuery continuationQuery negativeQuery'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

SLGCall class
	instanceVariableNames: 'continuationQuery negativeQuery'!

SLGCall class
	instanceVariableNames: 'continuationQuery negativeQuery'!

!SLGCall class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
call: aSoulTerm cid: anInteger
	
	^self new call: aSoulTerm cid: anInteger! !

!SLGCall class methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
continuationQuery
	
	^continuationQuery! !

!SLGCall class methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
continuationQuery: anObject
	
	continuationQuery := anObject! !

!SLGCall class methodsFor: 'initialize-release' stamp: 'AndyKellens 11/2/2011 09:53'!
initializeQueries
	
	| parseBlock |
	parseBlock := [:aQueryText | 
	SoulFactory current makeParser
		parse: aQueryText
		onError:
			[:text :pos | self error: 'Parser error: ' , text , 'at: ' , pos asString]].
	continuationQuery := parseBlock value:
			'if  ?Cont@(<?Id , ?Vars, ?Answer ,?Delayed>)'.
	negativeQuery := parseBlock value: 'if ?Cont@(<?Id, ?Vars, ?Delayed>)'! !

!SLGCall class methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
negativeQuery
	
	^negativeQuery! !

!SLGCall class methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
negativeQuery: anObject
	
	negativeQuery := anObject! !

!SLGCall methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
addAnswer: anAnswerTerm with: delayed
	"Add an answer for the call"

	
	answers
		add:
			(Array
				with: anAnswerTerm
				with: delayed copy)! !

!SLGCall methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
addNegativeWaitingId: anId variables: someVars delay: delay continuation: continuationPredicate
	"Add a negative waiting node"

	
	| positiveDelayed negativeDelayed |
	positiveDelayed := delay at: 1.
	negativeDelayed := delay at: 2.
	negativeWaitingNodes
		add:
			(WaitingNode callId: anId variables: someVars delayedPrimitives:
					positiveDelayed delayedNegatedPrimitives: negativeDelayed
				continuation: continuationPredicate)! !

!SLGCall methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
addToStack
	
	^self addToStack: false! !

!SLGCall methodsFor: 'private' stamp: 'AndyKellens 11/2/2011 09:53'!
addToStack: aBoolean
	
	| newdfn |
	newdfn := SoulFactory addCallToStack: self.
	aBoolean
		ifTrue:
			["dfn notNil ifTrue: [
			this is probably a mistake, remove later when everything works
			^self halt.
		]."

			dfn := newdfn.
			plink := dfn]! !

!SLGCall methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
addWaitingId: anId variables: someVars delay: delay continuation: continuationPredicate
	"Add a waiting node"

	
	| positiveDelayed negativeDelayed |
	positiveDelayed := delay at: 1.
	negativeDelayed := delay at: 2.
	waitingNodes
		add:
			(WaitingNode callId: anId variables: someVars delayedPrimitives:
					positiveDelayed delayedNegatedPrimitives: negativeDelayed
				continuation: continuationPredicate)! !

!SLGCall methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
answers
	
	^self answersShowMuffled: false! !

!SLGCall methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
answersShowMuffled: aBoolean
	
	| delayed accept |
	^(answers
		reject:
			[:answer | 
			delayed := answer at: 2.
			accept := (delayed at: 1) isEmpty and: [(delayed at: 2) isEmpty].
			aBoolean
				ifTrue:
					[accept
						ifFalse:
							[Transcript
								show:
									'muffling answer: ' , (answer at: 1) asString , ' ' , delayed asString.
							Transcript cr]].
			accept not]) collect: [:answer | answer at: 1]! !

!SLGCall methodsFor: 'initialize-release' stamp: 'AndyKellens 10/28/2011 13:09'!
call: aCallTerm cid: anInteger
	
	callTerm := aCallTerm.
	cid := anInteger.
	answers := OrderedCollection new.
	waitingNodes := OrderedCollection new.
	negativeWaitingNodes := OrderedCollection new.
	nlink := Float infinity.
	comp := false.	"slgQuery := parseBlock value: 'if slg' , (callTerm asString allButLast: 1) , ',' , cid asString , ')'."

	continuationQuery := SLGCall continuationQuery.
	negativeQuery := SLGCall negativeQuery! !

!SLGCall methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
cid
	
	^cid! !

!SLGCall methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
comp
	
	^comp! !

!SLGCall methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
comp: aBoolean
	
	comp := aBoolean! !

!SLGCall methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
dependsOnCallDeepBelow
	
	^self plink = self dfn
		and: [self dfn <= self nlink and: [self hasMaxNLink not]]! !

!SLGCall methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
dfn
	
	^dfn! !

!SLGCall methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
equivalenceStringFor: aTerm
	
	| string last first intervals |
	string := aTerm asString.
	intervals := OrderedCollection new.
	last := 0.
	[first := string
		findFirst: [:char | char = $?]
		startingAt: last + 1.
	first ~= 0]
		whileTrue:
			[last := (string
				findFirst: [:char | char isAlphaNumeric not]
				startingAt: first + 1) - 1.
			last < 0 ifTrue: [last := string size].
			intervals add: (first + 1 to: last)].
	intervals do: [:interval | interval do: [:i | string at: i put: $*]].
	^string copyWithout: $*! !

!SLGCall methodsFor: 'evaluation' stamp: 'AndyKellens 11/2/2011 09:53'!
evaluate
	"Start the evaluation of the call"

	
	| name list associations fun |
	self addToStack: true.	"evaluator := Soul.Evaluator
		eval: 'if slg' , (callTerm asString allButLast: 1) , ',' , cid asString , ')'
		in: callTerm definitionRepository."

	fun := callTerm functor.	"party in the parleh"

	fun isMessageFunctor
		ifTrue: [name := '#id:' , 'slg' , fun smalltalkValue asString]
		ifFalse: [name := 'slg' , fun smalltalkValue asString].
	list := ListTerm termSequence: callTerm termSequence.
	associations := OrderedCollection
		with: #Arguments -> list
		with: #Id -> cid.
	evaluator := SoulFactory current evaluatorForLogicQuery
		eval: 'if ' , name , '@(<?Id | ?Arguments >)'
		in: callTerm definitionRepository
		withAssociations: associations.
	evaluator allResults! !

!SLGCall methodsFor: 'evaluation' stamp: 'AndyKellens 11/2/2011 09:53'!
evaluateAnswersWith: aContinuation id: anId vars: vars delay: delay
	
	| answerevaluator delayed associations positive negative |
	"Evaluate the answers with a waitingNode"

	positive := delay at: 1.
	negative := delay at: 2.
	delayed := positive copy.
	answers
		do:
			[:anAnswer | 
			(positive isEmpty and: [negative isEmpty])
				ifFalse: [delayed add: (anAnswer at: 1)].
			associations := OrderedCollection
				with: #Delayed -> (Array with: delayed with: negative)
				with: #Cont -> aContinuation
				with: #Vars -> vars
				with: #Answer -> (anAnswer at: 1).
			associations add: #Id -> anId.
			answerevaluator := SoulFactory current evaluatorForLogicQuery
				evalQuery: (self prepareQuery: continuationQuery)
				in: callTerm definitionRepository
				withAssociations: associations.
			answerevaluator allResults]! !

!SLGCall methodsFor: 'evaluation' stamp: 'AndyKellens 11/2/2011 09:53'!
evaluateNegativeWaitingNode: aWaitingNode
	"boolean indicates undefined"

	
	| id continuation waitingevaluator vars associations newDelayed onlyDelayedAnswers hasNoAnswer |
	onlyDelayedAnswers := (answers
		contains:
			[:answer | 
			| delayed pos neg |
			delayed := answer at: 2.
			pos := delayed at: 1.
			neg := delayed at: 2.
			pos isEmpty and: [neg isEmpty]]) not.
	hasNoAnswer := answers isEmpty or: [onlyDelayedAnswers].
	hasNoAnswer
		ifTrue:
			[id := aWaitingNode callId.
			continuation := aWaitingNode continuation.
			vars := aWaitingNode variables.
			newDelayed := aWaitingNode delayedNegatedPrimitives.
			(answers isEmpty not and: [onlyDelayedAnswers])
				ifTrue:
					[newDelayed
						detect: [:x | x = self]
						ifNone: [newDelayed add: self]].
			associations := OrderedCollection
				with:
					#Delayed
						->
							(Array
								with: aWaitingNode delayedPrimitives
								with: newDelayed)
				with: #Cont -> continuation
				with: #Id -> id
				with: #Vars -> vars.
			waitingevaluator := SoulFactory current evaluatorForLogicQuery
				evalQuery: (self prepareQuery: negativeQuery)
				in: callTerm definitionRepository
				withAssociations: associations.
			waitingevaluator allResults]! !

!SLGCall methodsFor: 'evaluation' stamp: 'AndyKellens 11/2/2011 09:53'!
evaluateNegativeWaitingNodes: aBoolean deleteNodes: anotherBoolean
	"aBoolean indicates undefined"

	
	| id continuation waitingevaluator vars associations newDelayed onlyDelayedAnswers hasNoAnswer negNodes |
	onlyDelayedAnswers := (answers
		noneSatisfy:
			[:answer | 
			| delayed pos neg |
			delayed := answer at: 2.
			pos := delayed at: 1.
			neg := delayed at: 2.
			pos isEmpty and: [neg isEmpty]]).
	hasNoAnswer := answers isEmpty or: [onlyDelayedAnswers].
	hasNoAnswer
		ifTrue:
			[negNodes := negativeWaitingNodes.
			anotherBoolean ifTrue: [negativeWaitingNodes := OrderedCollection new].
			negNodes
				do:
					[:aWaitingNode | 
					id := aWaitingNode callId.
					continuation := aWaitingNode continuation.
					vars := aWaitingNode variables.
					newDelayed := aWaitingNode delayedNegatedPrimitives.
					(aBoolean or: [answers isEmpty not and: [onlyDelayedAnswers]])
						ifTrue:
							[newDelayed
								detect: [:x | x = self]
								ifNone: [newDelayed add: self]].
					associations := OrderedCollection
						with:
							#Delayed
								->
									(Array
										with: aWaitingNode delayedPrimitives
										with: newDelayed)
						with: #Cont -> continuation
						with: #Id -> id
						with: #Vars -> vars.
					waitingevaluator := SoulFactory current evaluatorForLogicQuery
						evalQuery: (Query condition: negativeQuery condition copy)
						in: callTerm definitionRepository
						withAssociations: associations.
					waitingevaluator allResults]]
		ifFalse:
			["negativeWaitingNodes isEmpty ifFalse: [
			^self halt: 'nodes should have been removed when answer was computed'.
		]."

			negativeWaitingNodes := OrderedCollection new]! !

!SLGCall methodsFor: 'evaluation' stamp: 'AndyKellens 11/2/2011 09:53'!
evaluateWaitingNodesWithAnswer: aTerm using: delayed
	
	| id continuation waitingevaluator vars associations newDelayed positive negative hasNoDelayed query |
	positive := delayed at: 1.
	negative := delayed at: 2.
	hasNoDelayed := positive isEmpty and: [negative isEmpty].
	hasNoDelayed
		ifTrue:
			["we have a real answer without waitingnodes. Any negative waiting node must fail"

			negativeWaitingNodes := OrderedCollection new].
	waitingNodes
		do:
			[:aWaitingNode | 
			id := aWaitingNode callId.
			continuation := aWaitingNode continuation.
			vars := aWaitingNode variables.
			newDelayed := aWaitingNode delayedPrimitives.
			hasNoDelayed ifFalse: [newDelayed add: aTerm].
			associations := OrderedCollection
				with:
					#Delayed
						->
							(Array
								with: newDelayed
								with: aWaitingNode delayedNegatedPrimitives)
				with: #Cont -> continuation
				with: #Vars -> vars
				with: #Answer -> aTerm.
			associations add: #Id -> id.	"waitingevaluator := Soul.Evaluator
			eval: ('if ' , (continuation asString, '(' , id asString , ',', vars asString, ',', aTerm asString ,', ?D', ')' )) asString
			in: callTerm definitionRepository
			withAssociations: associations."

			query := continuationQuery accept: CopyingVisitor new.
			waitingevaluator := SoulFactory current evaluatorForLogicQuery
				evalQuery: query
				in: callTerm definitionRepository
				withAssociations: associations.
			waitingevaluator allResults]! !

!SLGCall methodsFor: 'testing' stamp: 'AndyKellens 11/3/2011 10:53'!
hasMaxNLink
	"Checks if this has the maximum negative link"

	
	^nlink == Float infinity! !

!SLGCall methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
includesAnswer: anAnswerTerm using: delayed
	"Do we already include the answer?"

	
	| pos neg possibleAnswers |
	pos := ((delayed at: 1) collect: [:d | d cid]) sort.
	neg := ((delayed at: 2) collect: [:d | d cid]) sort.
	possibleAnswers := answers
		select: [:a | (a at: 1) isSLGEquivalentTo: anAnswerTerm].	"we now have all the answers, we now have to check if this new answer has the same delayed variables"

	possibleAnswers
		detect:
			[:a | 
			| del |
			del := a at: 2.
			((del at: 1) collect: [:d | d cid]) sort = pos
				and: [((del at: 2) collect: [:d | d cid]) sort = neg]]
		ifNone: [^false].
	^true! !

!SLGCall methodsFor: 'testing' stamp: 'AndyKellens 11/3/2011 10:55'!
isCompletelyEvaluated
	^self dfn = self plink and: [self hasMaxNLink]! !

!SLGCall methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
isNew
	"Used to detect if we are a newly created call"

	
	^evaluator == nil! !

!SLGCall methodsFor: 'testing' stamp: 'AndyKellens 11/3/2011 11:22'!
isSLGEquivalentTo: aCallTerm
	^aCallTerm isSLGEquivalentTo: callTerm! !

!SLGCall methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
nlink
	
	^nlink! !

!SLGCall methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
nlink: aNumber
	
	nlink := aNumber! !

!SLGCall methodsFor: 'accessing' stamp: 'AndyKellens 10/28/2011 13:11'!
nlinkToMax
	
	nlink := Float infinity! !

!SLGCall methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
plink
	
	^plink! !

!SLGCall methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
plink: aNumber
	
	plink := aNumber! !

!SLGCall methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
prepareQuery: aQuery
	"(Query condition: continuationQuery condition copy)"

	
	^aQuery accept: CopyingVisitor new! !

!SLGCall methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printOn: aStream
	
	| stringRepresentation |
	stringRepresentation := callTerm asString.
	aStream write: stringRepresentation! !

!SLGCall methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
removeWaitingNodes
	
	waitingNodes removeAll! !

!SLGCall methodsFor: 'accessing' stamp: 'AndyKellens 10/28/2011 13:11'!
setMinNLink: anInteger
	
	anInteger == Float infinity ifFalse: [nlink := nlink min: anInteger].
	^nlink! !

!SLGCall methodsFor: 'accessing' stamp: 'AndyKellens 10/28/2011 13:11'!
setMinPLink: anInteger
	
	anInteger == Float infinity ifFalse: [plink := plink min: anInteger].
	^plink! !

!SLGCall methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
simplifyAnswers: anSLGCall isNegated: aBoolean
	
	| delayed positive negative |
	answers copy
		do:
			[:answer | 
			delayed := answer at: 2.
			positive := delayed at: 1.
			negative := delayed at: 2.
			aBoolean
				ifTrue:
					["we are waiting on not(anSLGCall)"

					anSLGCall unfilteredAnswers isEmpty
						ifTrue:
							["this call has no answers, so we can remove this"

							negative := negative reject: [:x | x = anSLGCall]	"negative remove: anSLGCall."
]
						ifFalse:
							[anSLGCall answers isEmpty
								ifFalse:
									["we have a real answer, so our answer is incorrect"

									answers remove: answer]]]
				ifFalse:
					["we are waiting on anSLGCall"

					anSLGCall unfilteredAnswers isEmpty
						ifTrue:
							["SLGCall has no solutions, remove answer"

							answers remove: answer]
						ifFalse:
							[anSLGCall answers isEmpty
								ifFalse:
									["we have a real answer, so remove delayed literal"

									positive remove: anSLGCall]]]]! !

!SLGCall methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
unfilteredAnswers
	
	^answers! !

Object subclass: #SimpleTermVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

SimpleTermVisitor subclass: #CopyingVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!CopyingVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
callTermVisit: aCallTerm
	
	^aCallTerm class
		variable: (aCallTerm variable accept: self)
		term: (aCallTerm normalterm accept: self)! !

!CopyingVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
compoundVisit: aCompound
	
	^aCompound class
		functor: (aCompound functor accept: self)
		termSequence: (aCompound termSequence accept: self)
		astLink:
			(aCompound astLink == nil
				ifTrue: [nil]
				ifFalse: [aCompound astLink accept: self])! !

!CopyingVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
constantVisit: aConstant
	
	^aConstant class up: aConstant smalltalkValue! !

!CopyingVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
cutVisit: aCut
	
	^aCut class new! !

!CopyingVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
delayedVariableVisit: aVariable
	
	^aVariable class name: aVariable name! !

!CopyingVisitor methodsFor: 'visiting clauses' stamp: 'AndyKellens 11/2/2011 09:53'!
factVisit: aClause
	
	| copy |
	copy := SoulFactory current makeFact
		condition: (aClause condition accept: self)
		conclusion: (aClause conclusion accept: self).
	copy comment: aClause comment.
	^copy! !

!CopyingVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
keywordFunctorVisit: term
	"For convenience this method will by default forward the message request to multiPartFunctorVisit: as the visitor's behavior for keyword en message functors will in most cases be the same"

	
	^self multiPartFunctorVisit: term! !

!CopyingVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
messageFunctorVisit: term
	"For convenience this method will by default forward the message request to multiPartFunctorVisit: as the visitor's behavior for keyword en message functors will in most cases be the same"

	
	^self multiPartFunctorVisit: term! !

!CopyingVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
multiPartFunctorVisit: aFunctor
	"See comment in keywordFunctorVisit: and messageFunctorVisit:"

	
	^aFunctor class
		keywords: (aFunctor keywords collect: [:keyword | keyword accept: self])! !

!CopyingVisitor methodsFor: 'visiting clauses' stamp: 'sp 24/10/11 15:26'!
nativeClauseVisit: aClause
	
	^aClause class newWith: (aClause header accept: self)! !

!CopyingVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
objectVisit: anObject
	"By default this will *not* copy the upped object, just the term itself"

	
	^anObject class up: anObject smalltalkValue! !

!CopyingVisitor methodsFor: 'visiting clauses' stamp: 'AndyKellens 11/2/2011 09:53'!
queryVisit: aClause
	
	| copy |
	copy := SoulFactory current makeQuery
		condition: (aClause condition accept: self).
	copy comment: aClause comment.
	^copy! !

!CopyingVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
quotedCodeTermVisit: aQuotedCodeBlock
	"TODO: this wont work if we use the copyingvisitor to write a renaming tool for variables for example ..."

	
	^aQuotedCodeBlock class source: aQuotedCodeBlock source! !

!CopyingVisitor methodsFor: 'visiting terms' stamp: 'AndyKellens 11/2/2011 09:53'!
resultMessageTermVisit: rmTerm
	
	^SoulFactory current makeResultMessageTerm
		message: (rmTerm message accept: self)
		result: (rmTerm result accept: self)! !

!CopyingVisitor methodsFor: 'visiting clauses' stamp: 'AndyKellens 11/2/2011 09:53'!
ruleVisit: aClause
	
	| copy |
	copy := SoulFactory current makeRule
		condition: (aClause condition accept: self)
		conclusion: (aClause conclusion accept: self).
	copy comment: aClause comment.
	^copy! !

!CopyingVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
smalltalkTermVisit: anSTTerm
	"TODO: this might not work properly if we use the copyingvisitor to write a renaming tool for variables for example ..."

	"UGLY: yukky type test here"

	
	^anSTTerm class
		source: anSTTerm source
		variables:
			(anSTTerm variablesIncludingNils
				collect:
					[:x | 
					(x isKindOf: AbstractTerm)
						ifTrue: [x accept: self]
						ifFalse: [x]])
		content: anSTTerm content
		block: anSTTerm block! !

!CopyingVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
templateQueryTermVisit: aTemplateQueryTerm
	"TODO: this wont work if we use the copyingvisitor to write a renaming tool for variables for example ..."

	
	^aTemplateQueryTerm class
		source: aTemplateQueryTerm source
		type: aTemplateQueryTerm type! !

!CopyingVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
termSequenceVisit: aTermSequence
	
	^aTermSequence class
		terms: (aTermSequence terms collect: [:subTerm | subTerm accept: self])! !

!CopyingVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
unaryMessageFunctorVisit: unaryMessageFunctor
	
	^unaryMessageFunctor class
		message: (unaryMessageFunctor message accept: self)! !

!CopyingVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
underscoreVariableVisit: aVariable
	
	^aVariable class name: aVariable name! !

!CopyingVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
variableVisit: aVariable
	
	^(aVariable class name: aVariable name) setAddress: aVariable address! !

!CopyingVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
visitAnnotatedTerm: aTerm
	
	^aTerm class
		term: (aTerm term accept: self)
		annotation: (aTerm annotation accept: self)! !

CopyingVisitor subclass: #VariableUnwrapperVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!VariableUnwrapperVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
constantVisit: aConstant
	
	| rest |
	^('MetaVar*' match: aConstant name)
		ifTrue:
			[rest := aConstant name allButFirst: 7.
			('Var*' match: rest)
				ifTrue: [HiddenVariable name: rest]
				ifFalse: [Variable name: rest]]
		ifFalse: [aConstant class up: aConstant smalltalkValue]! !

!VariableUnwrapperVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
objectVisit: anObject
	
	| rest |
	^((anObject smalltalkValue isKindOf: Symbol)
		and: ['MetaVar*' match: anObject smalltalkValue])
		ifTrue:
			[rest := anObject smalltalkValue allButFirst: 7.
			('Var*' match: rest)
				ifTrue: [HiddenVariable name: rest]
				ifFalse: [Variable name: rest]]
		ifFalse: [anObject]! !

!VariableUnwrapperVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
smalltalkTermVisit: anSTTerm
	
	^self objectVisit: (anSTTerm evaluateIn: nil startAt: nil) soulUp! !

CopyingVisitor subclass: #VariableWrapperVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!VariableWrapperVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
underscoreVariableVisit: aVariable
	
	^Constant name: 'MetaVar' , aVariable name! !

!VariableWrapperVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
variableVisit: aVariable
	
	^Constant name: 'MetaVar' , aVariable name! !

SimpleTermVisitor subclass: #FixVisitor
	instanceVariableNames: 'dictionary counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!FixVisitor class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
new
	
	^super new initialize! !

!FixVisitor class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
newWithStartIndex: anIndex
	
	^super new initialize: anIndex! !

!FixVisitor methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
addVariables: aCollection
	
	aCollection
		do:
			[:aVar | 
			dictionary
				at: aVar name
				put: aVar address]! !

!FixVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
delayedVariableVisit: aVariable
	
	self variableVisit: aVariable! !

!FixVisitor methodsFor: 'initialize' stamp: 'sp 24/10/11 15:26'!
initialize
	
	dictionary := Dictionary new.
	counter := -1! !

!FixVisitor methodsFor: 'initialize' stamp: 'sp 24/10/11 15:26'!
initialize: aCounter
	
	dictionary := Dictionary new.
	counter := aCounter - 1! !

!FixVisitor methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
maxIndex
	
	^counter! !

!FixVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
quotedCodeTermVisit: aQuotedCodeBlock
	
	aQuotedCodeBlock variables do: [:var | var accept: self].
	aQuotedCodeBlock content do: [:var | var accept: self]! !

!FixVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
smalltalkTermVisit: anSTTerm
	
	| vars |
	vars := anSTTerm variables.
	(1 to: vars size) do: [:index | (vars at: index) accept: self]! !

!FixVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
variableVisit: aVariable
	
	dictionary
		at: aVariable name
		ifAbsentPut:
			[counter := counter + 1.
			counter].
	aVariable setAddress: (dictionary at: aVariable name)! !

SimpleTermVisitor subclass: #NamedVariableVisitor
	instanceVariableNames: 'doBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!NamedVariableVisitor commentStamp: '<historical>' prior: 0!
I walk a Soul parse tree and apply an action on every named variable of that tree. Underscore variables are thus skipped.

Instance Variables:
	doBlock	 <BlockClosure>	the action to be performed on named variables that are encountered

!

!NamedVariableVisitor class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
doBlock: aBlock
	
	^self new doBlock: aBlock! !

!NamedVariableVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
delayedVariableVisit: aVariable
	
	doBlock value: aVariable! !

!NamedVariableVisitor methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
doBlock: aBlock
	
	doBlock := aBlock! !

!NamedVariableVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
nativeClauseVisit: aNativeClause
	
	| variables |
	variables := aNativeClause variables.
	aNativeClause header do: [:el | el accept: self].
	variables do: [:var | doBlock value: var]! !

!NamedVariableVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
smalltalkTermVisit: anSTTerm
	
	| variables |
	variables := anSTTerm variables.
	(1 to: variables size) do: [:index | doBlock value: (variables at: index)]! !

!NamedVariableVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
templateQueryTermVisit: aTemplateQueryTerm
	
	aTemplateQueryTerm content do: [:subterm | subterm accept: self].
	aTemplateQueryTerm variables do: [:subterm | subterm accept: self].
	aTemplateQueryTerm parsetrees do: [:tree | tree accept: self].
	aTemplateQueryTerm queries do: [:query | (query at: 1) accept: self].
	aTemplateQueryTerm type accept: self! !

!NamedVariableVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
underscoreVariableVisit: aVariable
	
	^self! !

!NamedVariableVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
variableVisit: aVariable
	
	doBlock value: aVariable! !

NamedVariableVisitor subclass: #VariableAndUnderscoreVariableVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!VariableAndUnderscoreVariableVisitor commentStamp: '<historical>' prior: 0!
I walk a Soul parse tree and apply an action on every variable (both named and underscore variables) of that tree.!

VariableAndUnderscoreVariableVisitor subclass: #AllButHiddenVariablesVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!AllButHiddenVariablesVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
hiddenVariableVisit: aHiddenVariable
	"do nothing"
	
	! !

!VariableAndUnderscoreVariableVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
underscoreVariableVisit: aVariable
	
	doBlock value: aVariable! !

!SimpleTermVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
callTermVisit: aCallTerm
	
	aCallTerm variable accept: self.
	aCallTerm normalterm accept: self! !

!SimpleTermVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
compoundVisit: aCompound
	
	aCompound functor accept: self.
	aCompound termSequence accept: self.
	aCompound astLink == nil ifFalse: [aCompound astLink accept: self]! !

!SimpleTermVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
constantVisit: aConstant
	
	^aConstant! !

!SimpleTermVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
cutVisit: aCut
	
	^aCut! !

!SimpleTermVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
delayedVariableVisit: aVariable
	
	! !

!SimpleTermVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
emptyListConstantVisit: term
	
	^self constantVisit: term! !

!SimpleTermVisitor methodsFor: 'visiting clauses' stamp: 'sp 24/10/11 15:26'!
factVisit: aClause
	
	aClause condition accept: self.
	aClause conclusion accept: self! !

!SimpleTermVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
hiddenVariableVisit: aHiddenVariable
	
	^self variableVisit: aHiddenVariable! !

!SimpleTermVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
keywordFunctorVisit: term
	"For convenience this method will by default forward the message request to multiPartFunctorVisit: as the visitor's behavior for keyword en message functors will in most cases be the same"

	
	^self multiPartFunctorVisit: term! !

!SimpleTermVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
listTermVisit: term
	
	^self compoundVisit: term! !

!SimpleTermVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
messageFunctorVisit: term
	"For convenience this method will by default forward the message request to multiPartFunctorVisit: as the visitor's behavior for keyword en message functors will in most cases be the same"

	
	^self multiPartFunctorVisit: term! !

!SimpleTermVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
multiPartFunctorVisit: aFunctor
	"See comment in keywordFunctorVisit: and messageFunctorVisit:"

	
	^aFunctor keywords do: [:keyword | keyword accept: self]! !

!SimpleTermVisitor methodsFor: 'visiting clauses' stamp: 'sp 24/10/11 15:26'!
nativeClauseVisit: aClause
	
	! !

!SimpleTermVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
objectVisit: anObject
	
	^self! !

!SimpleTermVisitor methodsFor: 'visiting clauses' stamp: 'sp 24/10/11 15:26'!
queryVisit: aClause
	
	aClause condition accept: self! !

!SimpleTermVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
quotedCodeTermVisit: aQuotedCodeBlock
	
	aQuotedCodeBlock variables do: [:subterm | subterm accept: self]! !

!SimpleTermVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
resultMessageTermVisit: rmTerm
	
	rmTerm message accept: self.
	rmTerm result accept: self! !

!SimpleTermVisitor methodsFor: 'visiting clauses' stamp: 'sp 24/10/11 15:26'!
ruleVisit: aClause
	
	aClause condition accept: self.
	aClause conclusion accept: self! !

!SimpleTermVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
smalltalkTermVisit: anSTTerm
	"UGLY: should we also recursively visit the variables used in the smalltalk term by default?"
	
	! !

!SimpleTermVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
templateQueryTermVisit: aTemplateQueryTerm
	
	aTemplateQueryTerm content do: [:subterm | subterm accept: self].
	aTemplateQueryTerm variables do: [:subterm | subterm accept: self].
	aTemplateQueryTerm parsetrees do: [:tree | tree accept: self].
	aTemplateQueryTerm queries do: [:query | (query at: 1) accept: self].
	aTemplateQueryTerm type accept: self! !

!SimpleTermVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
termSequenceVisit: aTermSequence
	
	aTermSequence terms do: [:subTerm | subTerm accept: self]! !

!SimpleTermVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
unaryMessageFunctorVisit: unaryMessageFunctor
	
	^unaryMessageFunctor message accept: self! !

!SimpleTermVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
underscoreVariableVisit: aVariable
	
	! !

!SimpleTermVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
variableVisit: aVariable
	
	! !

!SimpleTermVisitor methodsFor: 'visiting terms' stamp: 'sp 24/10/11 15:26'!
visitAnnotatedTerm: anAnnotatedTerm
	
	anAnnotatedTerm term accept: self.
	anAnnotatedTerm annotation accept: self! !

Object subclass: #SoulFactory
	instanceVariableNames: ''
	classVariableNames: 'CallIdCounter CallsPerCID CallsPerPredicate Current DependentNegatedOn DependentOn NameCounter Repositories RepositoriesDependents SLGCallStack WaitList'
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!SoulFactory class methodsFor: 'SLG - auxiliary' stamp: 'AndyKellens 11/2/2011 10:15'!
addCallToStack: anSLGCall
	"returns the dfn (depth first number)"

	
	SLGCallStack add: anSLGCall.
	^SLGCallStack size! !

!SoulFactory class methodsFor: 'SLG - auxiliary' stamp: 'sp 24/10/11 15:26'!
addDependentCall: aCallTerm dependentOf: aWaitingNode
	
	| alreadyDependent |
	alreadyDependent := DependentOn
		at: aCallTerm
		ifAbsent: [OrderedCollection new].
	alreadyDependent add: aWaitingNode.
	DependentOn at: aCallTerm put: alreadyDependent! !

!SoulFactory class methodsFor: 'SLG - auxiliary' stamp: 'sp 24/10/11 15:26'!
addNegatedDependentCall: aCallTerm dependentOf: aWaitingNode
	
	| alreadyDependent |
	alreadyDependent := DependentNegatedOn
		at: aCallTerm
		ifAbsent: [OrderedCollection new].
	alreadyDependent add: aWaitingNode.
	DependentNegatedOn at: aCallTerm put: alreadyDependent! !

!SoulFactory class methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
addToWaitList: item
	
	WaitList add: item! !

!SoulFactory class methodsFor: 'SLG' stamp: 'AndyKellens 11/3/2011 11:10'!
answer: aHead forCID: anInteger using: delayed
	
	| call positiveDelayed negativeDelayed |
	positiveDelayed := delayed at: 1.
	negativeDelayed := delayed at: 2.
	call := CallsPerCID at: anInteger.
	(call includesAnswer: aHead using: delayed)
		ifFalse:
			[call addAnswer: aHead with: delayed.
			positiveDelayed
				do: [:aTerm | self addDependentCall: aTerm dependentOf: call].
			negativeDelayed
				do: [:aTerm | self addNegatedDependentCall: aTerm dependentOf: call].
			call evaluateWaitingNodesWithAnswer: aHead using: delayed]! !

!SoulFactory class methodsFor: 'SLG - auxiliary' stamp: 'sp 24/10/11 15:26'!
callForCallTerm: aCallTerm
	
	| callsForPredicate theCall |
	callsForPredicate := CallsPerPredicate
		at: aCallTerm predicate , aCallTerm multiplicity asString
		ifAbsentPut: [OrderedCollection new].
	theCall := callsForPredicate
		detect: [:aCall | aCall isSLGEquivalentTo: aCallTerm]
		ifNone: [self newSLGCallFor: aCallTerm inCollection: callsForPredicate].
	^theCall! !

!SoulFactory class methodsFor: 'SLG - auxiliary' stamp: 'AndyKellens 11/3/2011 10:57'!
completeCallTerm: aCallTerm
	
	| poppedTerms copiedTerms positive negative justBelow |
	aCallTerm isCompletelyEvaluated
		ifTrue:
			[poppedTerms := self popUntilCallTerm: aCallTerm.
			poppedTerms asSet
				do:
					[:aTerm | 
					aTerm comp: true.
					self simplifyDependencyCallsFor: aTerm.
					aTerm removeWaitingNodes.
					aTerm evaluateNegativeWaitingNodes: false deleteNodes: true].
			^self].
	aCallTerm dependsOnCallDeepBelow
		ifTrue:
			[copiedTerms := self copyUntilCallTerm: aCallTerm.
			copiedTerms
				do:
					[:aTerm | 
					aTerm nlinkToMax.	"return undefined to negative waiting nodes"

					aTerm evaluateNegativeWaitingNodes: true deleteNodes: false].
			positive := Float infinity.
			negative := Float infinity.
			copiedTerms reverse
				do:
					[:aTerm | 
					aTerm plink == Float infinity
						ifFalse: [positive := positive min: aTerm plink].
					aTerm nlink == Float infinity
						ifFalse: [negative := negative min: aTerm nlink].
					aTerm plink: positive.
					aTerm nlink: negative.
					self completeCallTerm: aTerm].
			^self].
	justBelow := self justBelowTerm: aCallTerm.
	justBelow setMinPLink: aCallTerm plink.
	justBelow setMinNLink: aCallTerm nlink.
	^self! !

!SoulFactory class methodsFor: 'SLG - auxiliary' stamp: 'AndyKellens 11/2/2011 10:15'!
copyUntilCallTerm: aCallTerm
	
	| result index |
	index := SLGCallStack lastIndexOf: aCallTerm.
	result := SLGCallStack
		copyFrom: index
		to: SLGCallStack size.
	^result! !

!SoulFactory class methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
current
	
	^Current! !

!SoulFactory class methodsFor: '*SOUL-Kernel' stamp: 'sp 24/10/11 15:26'!
evaluator: aString
	
	^Soul at: aString! !

!SoulFactory class methodsFor: '*SOUL-Kernel' stamp: 'AndyKellens 11/2/2011 09:53'!
evaluators
	
	^SoulEvaluator withAllSubclasses collect: [:e | e name]! !

!SoulFactory class methodsFor: 'SLG - auxiliary' stamp: 'sp 24/10/11 15:26'!
getDependentCalls: aCallTerm
	
	^DependentOn
		at: aCallTerm
		ifAbsent: [OrderedCollection new]! !

!SoulFactory class methodsFor: 'SLG - auxiliary' stamp: 'sp 24/10/11 15:26'!
getDependentNegatedCalls: aCallTerm
	
	^DependentNegatedOn
		at: aCallTerm
		ifAbsent: [OrderedCollection new]! !

!SoulFactory class methodsFor: 'initialize-release' stamp: 'sp 24/10/11 15:26'!
initialize
	
	WaitList := OrderedCollection new.
	NameCounter := 0.
	Repositories := Dictionary new.
	RepositoriesDependents := Set new.
	self resetSLGTables! !

!SoulFactory class methodsFor: 'initialize-release' stamp: 'sp 24/10/11 15:26'!
initialize: aFactory
	
	Current := aFactory! !

!SoulFactory class methodsFor: 'installing' stamp: 'AndyKellens 11/2/2011 09:53'!
install
	
	SoulFactory current class = self ifFalse: [self initialize: self new]! !

!SoulFactory class methodsFor: 'SLG - auxiliary' stamp: 'AndyKellens 11/2/2011 10:15'!
justBelowTerm: aCallTerm
	
	| index |
	index := SLGCallStack lastIndexOf: aCallTerm.
	^SLGCallStack at: index - 1! !

!SoulFactory class methodsFor: 'SLG - auxiliary' stamp: 'sp 24/10/11 15:26'!
newSLGCallFor: aLogicTerm inCollection: aCollection
	
	| theCall |
	theCall := SLGCall
		call: aLogicTerm
		cid: self uniqueCallId.
	aCollection add: theCall.
	CallsPerCID
		at: theCall cid
		put: theCall.
	^theCall! !

!SoulFactory class methodsFor: 'SLG - auxiliary' stamp: 'AndyKellens 11/2/2011 10:15'!
popUntilCallTerm: aCallTerm
	
	| result index |
	index := SLGCallStack lastIndexOf: aCallTerm.
	result := SLGCallStack removeLast: SLGCallStack size - index + 1.
	^result! !

!SoulFactory class methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
processWaitList
	
	WaitList do: [:block | block value].
	WaitList := OrderedCollection new! !

!SoulFactory class methodsFor: 'SLG - auxiliary' stamp: 'AndyKellens 11/2/2011 10:15'!
resetSLGTables
	
	CallsPerCID := Dictionary new.
	CallsPerPredicate := Dictionary new.
	CallIdCounter := 0.
	SLGCallStack := OrderedCollection new.
	DependentOn := Dictionary new.
	DependentNegatedOn := Dictionary new! !

!SoulFactory class methodsFor: 'SLG - auxiliary' stamp: 'sp 24/10/11 15:26'!
simplifyDependencyCallsFor: aCallTerm
	
	| positiveDependents negativeDependents |
	positiveDependents := self getDependentCalls: aCallTerm.
	negativeDependents := self getDependentNegatedCalls: aCallTerm.
	positiveDependents
		do: [:aCall | aCall simplifyAnswers: aCallTerm isNegated: false].
	negativeDependents
		do: [:aCall | aCall simplifyAnswers: aCallTerm isNegated: true]! !

!SoulFactory class methodsFor: 'SLG' stamp: 'AndyKellens 11/3/2011 11:07'!
slg: aCallTerm
	
	| theCall |
	theCall := self callForCallTerm: aCallTerm.
	theCall comp
		ifFalse:
			[theCall evaluate.
			self completeCallTerm: theCall].
	^theCall answersShowMuffled: true! !

!SoulFactory class methodsFor: 'SLG' stamp: 'sp 24/10/11 15:26'!
slgcall: aCallTerm forCID: anInteger variables: vars delay: delay continuation: cont
	
	| call otherCall |
	call := self callForCallTerm: aCallTerm.
	otherCall := CallsPerCID at: anInteger.
	call addWaitingId: anInteger variables: vars delay: delay continuation:
			cont.
	call isNew
		ifTrue:
			[call evaluate.
			self completeCallTerm: call.
			otherCall comp
				ifFalse:
					[otherCall setMinPLink: call plink.
					otherCall setMinNLink: call nlink]]
		ifFalse:
			[otherCall setMinPLink: call plink.
			otherCall setMinNLink: call nlink.
			call evaluateAnswersWith: cont id: anInteger vars: vars delay: delay]! !

!SoulFactory class methodsFor: 'SLG' stamp: 'sp 24/10/11 15:26'!
slgnot: aCallTerm forCID: anInteger variables: vars delay: delay continuation: cont
	
	| call otherCall |
	call := self callForCallTerm: aCallTerm.
	otherCall := CallsPerCID at: anInteger.
	call isNew
		ifTrue:
			[call addNegativeWaitingId: anInteger variables: vars delay: delay
				continuation: cont.
			call evaluate.
			self completeCallTerm: call.
			call comp
				ifFalse:
					[call hasMaxNLink
						ifFalse: [otherCall setMinNLink: (call nlink min: call plink)]
						ifTrue: [otherCall setMinNLink: call plink]]]
		ifFalse:
			[call answers isEmpty
				ifTrue:
					["call does not have an answer without delayed vars"

					call comp
						ifFalse:
							[call addNegativeWaitingId: anInteger variables: vars delay: delay
								continuation: cont.	"call evaluateAnswersWith: cont id: anInteger vars: vars delay: delay."

							call hasMaxNLink
								ifFalse: [otherCall setMinNLink: (call nlink min: call plink)]
								ifTrue: [otherCall setMinNLink: call plink]]
						ifTrue:
							[call
								evaluateNegativeWaitingNode:
									(WaitingNode
										callId: anInteger
										variables: vars
										delayedPrimitives: (delay at: 1) copy
										delayedNegatedPrimitives: (delay at: 2) copy
										continuation: cont)]]]! !

!SoulFactory class methodsFor: 'SLG - auxiliary' stamp: 'sp 24/10/11 15:26'!
uniqueCallId
	
	CallIdCounter := CallIdCounter + 1.
	^CallIdCounter! !

!SoulFactory class methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
uniqueCounter
	
	NameCounter := NameCounter + 1.
	^NameCounter! !

!SoulFactory class methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
uniqueName
	
	^'Var' , self uniqueCounter asString! !

!SoulFactory methodsFor: 'symbiotic clause support' stamp: 'sp 24/10/11 15:26'!
collectionMemberBlockWithTermPointer: aTermPointer andEnvironment: anEnvironment
	"Returns block to be used in symbiotic implementation of collectionMember/2 clause. Called at run-time. Specialized for fuzzy logic. "

	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'annotated terms' stamp: 'sp 24/10/11 15:26'!
defaultAnnotation
	"The default annotation for terms for which no annotation is provided."

	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'evaluators' stamp: 'sp 24/10/11 15:26'!
evaluatorForLogicQuery
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'evaluators' stamp: 'sp 24/10/11 15:26'!
evaluatorForTemplateCompilation
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'evaluators' stamp: 'sp 24/10/11 15:26'!
evaluatorForTemplateParsing
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
isCrispLogic
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'native clauses' stamp: 'sp 24/10/11 15:26'!
makeAndClause
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeAnnotatedTerm
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'kernel' stamp: 'sp 24/10/11 15:26'!
makeBinding
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeCallTerm
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'kernel' stamp: 'sp 24/10/11 15:26'!
makeChoiceFrame
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'native clauses' stamp: 'sp 24/10/11 15:26'!
makeClauseClause
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeCompound
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeConstant
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeCut
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeDelayedVariable
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeEmptyList
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'native clauses' stamp: 'sp 24/10/11 15:26'!
makeEnvLookupClause
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'kernel' stamp: 'sp 24/10/11 15:26'!
makeEnvironment
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'hornClauses' stamp: 'sp 24/10/11 15:26'!
makeFact
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'kernel' stamp: 'sp 24/10/11 15:26'!
makeFrame
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'native clauses' stamp: 'sp 24/10/11 15:26'!
makeGetEnvClause
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'native clauses' stamp: 'sp 24/10/11 15:26'!
makeGetRepositoryClause
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeHiddenVariable
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'hornClauses' stamp: 'sp 24/10/11 15:26'!
makeHornClause
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'repository' stamp: 'sp 24/10/11 15:26'!
makeImportRepository
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeKeywordFunctor
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeList
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeMessageFunctor
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeMessageTerm
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'parser' stamp: 'sp 24/10/11 15:26'!
makeMethodParser
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'visitors' stamp: 'sp 24/10/11 15:26'!
makeNamedVariableVisitor
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'kernel' stamp: 'sp 24/10/11 15:26'!
makeNativeResolver
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeNegVariable
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'native clauses' stamp: 'sp 24/10/11 15:26'!
makeNotClause
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'native clauses' stamp: 'sp 24/10/11 15:26'!
makeOrClause
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makePair
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'parser' stamp: 'sp 24/10/11 15:26'!
makeParser
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makePosVariable
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'hornClauses' stamp: 'sp 24/10/11 15:26'!
makeProgramSequence
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'hornClauses' stamp: 'sp 24/10/11 15:26'!
makeQuery
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeQuotedCodeConstant
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'parser' stamp: 'sp 24/10/11 15:26'!
makeQuotedCodeParser
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeQuotedCodeTerm
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'repository' stamp: 'sp 24/10/11 15:26'!
makeRepository
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'kernel' stamp: 'sp 24/10/11 15:26'!
makeResolutionResult
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'kernel' stamp: 'sp 24/10/11 15:26'!
makeResolver
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeResultMessageTerm
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'kernel' stamp: 'sp 24/10/11 15:26'!
makeResults
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'hornClauses' stamp: 'sp 24/10/11 15:26'!
makeRule
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'kernel' stamp: 'sp 24/10/11 15:26'!
makeRuleSelector
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'native clauses' stamp: 'sp 24/10/11 15:26'!
makeSetResolverClause
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeSmalltalkTerm
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'parser' stamp: 'sp 24/10/11 15:26'!
makeSmalltalkTermParser
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'kernel' stamp: 'sp 24/10/11 15:26'!
makeStack
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeTemplateQuery
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeTermSequence
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeUnaryMessageFunctor
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeUnderscoreVariable
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeUppedObject
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeVarArgsCompound
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeVariable
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'visitors' stamp: 'sp 24/10/11 15:26'!
makeVariableAndUnderscoreVariableVisitor
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'native clauses' stamp: 'sp 24/10/11 15:26'!
makeWriteToPrologClause
	
	^self subclassResponsibility! !

!SoulFactory methodsFor: 'progress notification' stamp: 'sp 24/10/11 15:26'!
progressNotificationClass
	
	^self subclassResponsibility! !

SoulFactory subclass: #StandardSoulFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!StandardSoulFactory class methodsFor: 'initialize-release' stamp: 'sp 24/10/11 15:26'!
initialize
	
	super initialize.
	super initialize: self new! !

!StandardSoulFactory methodsFor: 'symbiotic clause support' stamp: 'AndyKellens 11/2/2011 09:53'!
collectionMemberBlockWithTermPointer: aTermPointer andEnvironment: anEnvironment
	"Returns block to be used in symbiotic implementation of collectionMember/2 clause. Called at run-time. Specialized for fuzzy logic such that the unification degree of the first argument with an element of the collection is taken into account. "

	
	^[:anArg | 
	| hisIndex |
	hisIndex := anEnvironment startUnify: 0.
	(aTermPointer term soulUp
		unifyWith: anArg soulUp
		inEnv: anEnvironment
		myIndex: aTermPointer envIndex
		hisIndex: hisIndex
		inSource: false)
		ifTrue:
			[SoulFactory current makeResolutionResult
				condition: OrderedCollection new
				rollbackInfo: anEnvironment rollbackInfo
				conditionsEnvIndex: nil
				cutState: false]
		ifFalse:
			[anEnvironment rollback.
			nil]]! !

!StandardSoulFactory methodsFor: 'annotated terms' stamp: 'sp 24/10/11 15:26'!
defaultAnnotation
	"The default annotation for terms for which no annotation is provided, only used for generalized annotated logic or fuzzy logics."

	
	^1 soulUp! !

!StandardSoulFactory methodsFor: 'evaluators' stamp: 'AndyKellens 11/2/2011 09:53'!
evaluatorForLogicQuery
	
	^SoulEvaluator! !

!StandardSoulFactory methodsFor: 'evaluators' stamp: 'sp 24/10/11 15:26'!
evaluatorForTemplateCompilation
	
	^self evaluatorForLogicQuery! !

!StandardSoulFactory methodsFor: 'evaluators' stamp: 'sp 24/10/11 15:26'!
evaluatorForTemplateParsing
	
	^self evaluatorForLogicQuery! !

!StandardSoulFactory methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
isCrispLogic
	
	^true! !

!StandardSoulFactory methodsFor: 'native clauses' stamp: 'sp 24/10/11 15:26'!
makeAndClause
	
	^AndClause! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeAnnotatedTerm
	
	^AnnotatedTerm! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeCallTerm
	
	^CallTerm! !

!StandardSoulFactory methodsFor: 'native clauses' stamp: 'sp 24/10/11 15:26'!
makeClauseClause
	
	^ClauseClause! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeCompound
	
	^CompoundTerm! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeConstant
	
	^Constant! !

!StandardSoulFactory methodsFor: 'hornClauses' stamp: 'sp 24/10/11 15:26'!
makeCut
	
	^Cut! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeDelayedVariable
	
	^DelayedVariable! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeEmptyList
	
	^EmptyListConstant! !

!StandardSoulFactory methodsFor: 'native clauses' stamp: 'sp 24/10/11 15:26'!
makeEnvLookupClause
	
	^EnvLookupClause! !

!StandardSoulFactory methodsFor: 'kernel' stamp: 'sp 24/10/11 15:26'!
makeEnvironment
	
	^Environment! !

!StandardSoulFactory methodsFor: 'hornClauses' stamp: 'sp 24/10/11 15:26'!
makeFact
	
	^Fact! !

!StandardSoulFactory methodsFor: 'native clauses' stamp: 'sp 24/10/11 15:26'!
makeGetEnvClause
	
	^GetEnvClause! !

!StandardSoulFactory methodsFor: 'native clauses' stamp: 'sp 24/10/11 15:26'!
makeGetRepositoryClause
	
	^GetRepositoryClause! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeHiddenVariable
	
	^HiddenVariable! !

!StandardSoulFactory methodsFor: 'hornClauses' stamp: 'sp 24/10/11 15:26'!
makeHornClause
	
	^HornClause! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeKeywordFunctor
	
	^KeywordFunctor! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeList
	
	^ListTerm! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeMessageFunctor
	
	^MessageFunctor! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeMessageTerm
	
	^MessageTerm! !

!StandardSoulFactory methodsFor: 'parsers' stamp: 'sp 24/10/11 15:26'!
makeMethodParser
	
	^SoulMethodCompiler! !

!StandardSoulFactory methodsFor: 'visitors' stamp: 'sp 24/10/11 15:26'!
makeNamedVariableVisitor
	
	^NamedVariableVisitor! !

!StandardSoulFactory methodsFor: 'kernel' stamp: 'sp 24/10/11 15:26'!
makeNativeResolver
	
	^NativeResolver! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeNegVariable
	
	^NegVariable! !

!StandardSoulFactory methodsFor: 'native clauses' stamp: 'sp 24/10/11 15:26'!
makeNotClause
	
	^NotClause! !

!StandardSoulFactory methodsFor: 'native clauses' stamp: 'sp 24/10/11 15:26'!
makeOrClause
	
	^OrClause! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makePair
	
	^PairTerm! !

!StandardSoulFactory methodsFor: 'parsers' stamp: 'sp 24/10/11 15:26'!
makeParser
	
	^SoulParser! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makePosVariable
	
	^PosVariable! !

!StandardSoulFactory methodsFor: 'hornClauses' stamp: 'sp 24/10/11 15:26'!
makeProgramSequence
	
	^ProgramSequence! !

!StandardSoulFactory methodsFor: 'hornClauses' stamp: 'sp 24/10/11 15:26'!
makeQuery
	
	^Query! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeQuotedCodeConstant
	
	^QuotedCodeConstant! !

!StandardSoulFactory methodsFor: 'parsers' stamp: 'sp 24/10/11 15:26'!
makeQuotedCodeParser
	
	^QuotedCodeParser! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeQuotedCodeTerm
	
	^QuotedCodeTerm! !

!StandardSoulFactory methodsFor: 'repository' stamp: 'sp 24/10/11 15:26'!
makeRepository
	
	^LogicRepository! !

!StandardSoulFactory methodsFor: 'kernel' stamp: 'sp 24/10/11 15:26'!
makeResolutionResult
	
	^ResolutionResult! !

!StandardSoulFactory methodsFor: 'kernel' stamp: 'sp 24/10/11 15:26'!
makeResolver
	
	^Resolver! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeResultMessageTerm
	
	^ResultMessageTerm! !

!StandardSoulFactory methodsFor: 'kernel' stamp: 'sp 24/10/11 15:26'!
makeResults
	
	^Results! !

!StandardSoulFactory methodsFor: 'hornClauses' stamp: 'sp 24/10/11 15:26'!
makeRule
	
	^Rule! !

!StandardSoulFactory methodsFor: 'kernel' stamp: 'sp 24/10/11 15:26'!
makeRuleSelector
	
	^DepthFirstRuleSelector! !

!StandardSoulFactory methodsFor: 'native clauses' stamp: 'sp 24/10/11 15:26'!
makeSetResolverClause
	
	^SetResolverClause! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeSmalltalkTerm
	
	^SmalltalkTerm! !

!StandardSoulFactory methodsFor: 'parsers' stamp: 'sp 24/10/11 15:26'!
makeSmalltalkTermParser
	
	^SmalltalkTermParser! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeTemplateQuery
	
	^TemplateQueryTerm! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeTermSequence
	
	^TermSequence! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeUnaryMessageFunctor
	
	^UnaryMessageFunctor! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeUnderscoreVariable
	
	^UnderscoreVariable! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeUppedObject
	
	^UppedObject! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeVarArgsCompound
	
	^VarArgsCompoundTerm! !

!StandardSoulFactory methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
makeVariable
	
	^Variable! !

!StandardSoulFactory methodsFor: 'visitors' stamp: 'sp 24/10/11 15:26'!
makeVariableAndUnderscoreVariableVisitor
	
	^VariableAndUnderscoreVariableVisitor! !

!StandardSoulFactory methodsFor: 'native clauses' stamp: 'sp 24/10/11 15:26'!
makeWriteToPrologClause
	
	^WriteToPrologClause! !

!StandardSoulFactory methodsFor: 'progress notification' stamp: 'sp 24/10/11 15:26'!
progressNotificationClass
	
	^Notice! !

Object subclass: #TermPointer
	instanceVariableNames: 'envIndex term nextTerm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!TermPointer class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
term: aTerm envIndex: anEnvIndex
	
	^self new term: aTerm envIndex: anEnvIndex! !

!TermPointer class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
term: aTerm envIndex: anEnvIndex nextTerm: aTermPointer
	
	^self new term: aTerm envIndex: anEnvIndex nextTerm: aTermPointer! !

!TermPointer methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
displayString
	
	^term displayString! !

!TermPointer methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
envIndex
	
	^envIndex! !

!TermPointer methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
nextTerm
	
	^nextTerm! !

!TermPointer methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
nextTerm: anObject
	
	nextTerm := anObject! !

!TermPointer methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printOn: aStream
	
	(term species == Environment
		or:
			[(term isKindOf: UppedObject)
				and: [term smalltalkValue species == Environment]])
		ifTrue: [aStream write: '**env**']
		ifFalse: [term printOn: aStream].
	aStream write: ' @ '.
	envIndex printOn: aStream.
	aStream write: ':'.
	nextTerm printOn: aStream! !

!TermPointer methodsFor: 'resolving' stamp: 'sp 24/10/11 15:26'!
resolveIn: anEnv
	
	^term resolveIn: anEnv startAt: envIndex! !

!TermPointer methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
term
	
	^term! !

!TermPointer methodsFor: 'initialize' stamp: 'sp 24/10/11 15:26'!
term: aTerm envIndex: anEnvIndex
	
	term := aTerm.
	envIndex := anEnvIndex! !

!TermPointer methodsFor: 'initialize' stamp: 'sp 24/10/11 15:26'!
term: aTerm envIndex: anEnvIndex nextTerm: aTermPointer
	
	term := aTerm.
	envIndex := anEnvIndex.
	nextTerm := aTermPointer! !

Object subclass: #WaitingNode
	instanceVariableNames: 'callId variables delayedPrimitives delayedNegatedPrimitives continuation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Kernel'!

!WaitingNode class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
callId: aNumber variables: aString delayedPrimitives: aCollection delayedNegatedPrimitives: anotherCollection continuation: anotherString
	
	^self new callId: aNumber variables: aString delayedPrimitives:
			aCollection delayedNegatedPrimitives: anotherCollection continuation:
			anotherString! !

!WaitingNode methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
callId
	
	^callId! !

!WaitingNode methodsFor: 'initialize-release' stamp: 'sp 24/10/11 15:26'!
callId: aNumber variables: aString delayedPrimitives: aCollection delayedNegatedPrimitives: anotherCollection continuation: anotherString
	
	callId := aNumber.
	variables := aString.
	delayedPrimitives := aCollection.
	delayedNegatedPrimitives := anotherCollection.
	continuation := anotherString! !

!WaitingNode methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
continuation
	
	^continuation! !

!WaitingNode methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
delayedNegatedPrimitives
	
	^delayedNegatedPrimitives! !

!WaitingNode methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
delayedPrimitives
	
	^delayedPrimitives! !

!WaitingNode methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
variables
	
	^variables! !
SoulFactory initialize!
StandardSoulFactory initialize!
